/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
function Checkbox( sId, mainId, imgId, labelId, enabled, imgNorm, imgCheck, imgDisabled, imgTip,
                   highlightFgColor, highlightBgColor, selectedFgColor, selectedBgColor )
{
  if( sId )
  {
    this.init(sId, mainId, imgId, labelId, enabled, imgNorm, imgCheck, imgDisabled, imgTip,
            highlightFgColor, highlightBgColor, selectedFgColor, selectedBgColor);
  }
}
Checkbox.prototype.init = function( sId, mainId, imgId, labelId, enabled, imgNorm, imgCheck, imgDisabled, imgTip,
                                    highlightFgColor, highlightBgColor, selectedFgColor, selectedBgColor )
{
  ;
  this.sId = sId;
  this.mainId = mainId;
  this.imgId = imgId;
  this.labelId = labelId;
  this.highlightFgColor = highlightFgColor;
  this.highlightBgColor = highlightBgColor;
  this.selectedFgColor = selectedFgColor;
  this.selectedBgColor = selectedBgColor;
  if( enabled == undefined || enabled == null ) 
    enabled = true;
  this.state = {
    pressed : false,       
    enabled : enabled,     
    tip     : false,       
    images : {
      normal   : imgNorm,
      checked  : imgCheck,
      tip      : imgTip,
      disabled : imgDisabled
    }
  };
  if( this.state.enabled )
    this.setStatus('enable');
  else
    this.setStatus('disable');
  this.createMouseOverEventHandler();
  this.createMouseOutEventHandler();
  this.createMouseClickEventHandler();
  if( this.mainId )
  {
    Browser.addEventListener(this.mainId, Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
    Browser.addEventListener(this.mainId, Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
    Browser.addEventListener(this.mainId, Browser.eventNames.CLICK, this.mouseClickHandler);
    if( !this.labelId )
      this.fgElement = this.mainId;
    else
      this.fgElement = this.labelId;
    this.bgElement = this.mainId;
  }
  else
  {
    if( this.imgId )
    {
      Browser.addEventListener(this.imgId, Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
      Browser.addEventListener(this.imgId, Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
      Browser.addEventListener(this.imgId, Browser.eventNames.CLICK, this.mouseClickHandler);
    }
    if( this.labelId )
    {
      Browser.addEventListener(this.labelId, Browser.eventNames.MOUSEOVER, this.mouseOverHandler);
      Browser.addEventListener(this.labelId, Browser.eventNames.MOUSEOUT, this.mouseOutHandler);
      Browser.addEventListener(this.labelId, Browser.eventNames.CLICK, this.mouseClickHandler);
      this.fgElement = this.labelId;
      this.bgElement = this.labelId;
    }
  }
  this.normalFgColor = this.getNormalColor(this.fgElement, 'color', '#000000');
  this.normalBgColor = this.getNormalColor(this.bgElement, 'backgroundColor', '#FFFFFF');
} 
Checkbox.prototype.getId = function()
{
	return this.sId;
}
Checkbox.prototype.getNormalColor = function( element, style, defaultColor )
{
  if( element )
  {
    var color = Browser.getStyleById(element, style);
    if( color )
    {
      return color
    }
  }
  return defaultColor;
}
Checkbox.prototype.setHighlightFgColor = function( color )
{
  this.highlightFgColor = color;
}
Checkbox.prototype.setHighlightBgColor = function( color )
{
  this.highlightBgColor = color;
}
Checkbox.prototype.setSelectedFgColor = function( color )
{
  this.selectedFgColor = color;
}
Checkbox.prototype.setSelectedBgColor = function( color )
{
  this.selectedBgColor = color;
}
Checkbox.prototype.setCheckedAction = function( action )
{
  this.checkedAction = action;
}
Checkbox.prototype.setUncheckedAction = function( action )
{
  this.uncheckedAction = action;
}
Checkbox.prototype.getCheckAction = function()
{
  return new ObjectMethodAction(this, "setStatus", "check");
}
Checkbox.prototype.getUncheckAction = function()
{
  return new ObjectMethodAction(this, "setStatus", "uncheck");
}
Checkbox.prototype.getTipAction = function()
{
  return new ObjectMethodAction(this, "setStatus", "tip");
}
Checkbox.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, "setStatus", "disable");
}
Checkbox.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, "setStatus", "enable");
}
Checkbox.prototype.setStatus = function( status )
{
  ;
  switch( status )
          {
    case "check":
      this.state.pressed = true;
      this.state.tip = false;
      break;
    case "uncheck":
      this.state.pressed = false;
      this.state.tip = false;
      break;
    case "tip":
      this.state.pressed = true;
      this.state.tip = true;
      break;
    case "disable":
      this.state.enabled = false;
      break;
    case "enable":
      this.state.enabled = true;
      break;
  }
  this.displayState(this.name);
}
Checkbox.prototype.displayState = function()
{
  var imgSrc;
  if( this.state.pressed )
  {
    imgSrc = (this.state.tip ? this.state.images.tip : this.state.images.checked);
    this.setColors(this.selectedFgColor, this.selectedBgColor);
  }
  else
  {
    imgSrc = this.state.images.normal;
    this.setColors(this.normalFgColor, this.normalBgColor);
  }
  if( !this.state.enabled && !this.state.tip ) 
  {
    imgSrc = (this.state.disabled ? this.state.images.disabled : this.state.images.checked);
    this.setColors(this.normalFgColor, this.normalBgColor);
  }
  if( this.imgId && imgSrc ) 
  {
    Browser.setImageSourceById(this.imgId, imgSrc);
  }
} 
Checkbox.prototype.setColors = function( fgColor, bgColor )
{
  if( this.fgElement && fgColor )
    Browser.changeStyleById(this.fgElement, "color", fgColor);
  if( this.bgElement && bgColor )
    Browser.changeStyleById(this.mainId, "backgroundColor", bgColor);
}
Checkbox.prototype.createMouseOverEventHandler = function()
{
  var me = this;
  this.mouseOverHandler = function( event )
  {
    if( !event )
      event = window.event;
    if( me.state.enabled )
    {
      if( me.state.pressed )
      {
        me.setColors(me.selectedFgColor, me.highlightBgColor);
      }
      else
      {
        me.setColors(me.highlightFgColor, me.highlightBgColor);
      }
    }
    else
    {
      me.setColors(me.normalFgColor, me.normalBgColor);
    }
  }
}
Checkbox.prototype.createMouseOutEventHandler = function()
{
  var me = this;
  this.mouseOutHandler = function( event )
  {
    if( !event )
      event = window.event;
    if( me.state.enabled )
    {
      if( me.state.pressed )
      {
        me.setColors(me.selectedFgColor, me.selectedBgColor);
      }
      else
      {
        me.setColors(me.normalFgColor, me.normalBgColor);
      }
    }
    else
    {
      me.setColors(me.normalFgColor, me.normalBgColor);
    }
  }
}
Checkbox.prototype.createMouseClickEventHandler = function()
{
  var me = this;
  this.mouseClickHandler = function( event )
  {
    if( !event )
      event = window.event;
    if( me.state.enabled )
    {
      me.state.pressed = !me.state.pressed;
      me.displayState();
      if( me.state.pressed )
      {
        if( me.checkedAction )
        {
          me.checkedAction.invoke();
        }
      }
      else
      {
        if( me.uncheckedAction )
        {
          me.uncheckedAction.invoke();
        }
      }
    }
    else
    {
      me.setColors(me.disabledFgColor, me.disabledBgColor);
    }
  }
}
