/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
ImagePushButton.prototype = new DomletCtr();
ImagePushButton.prototype.constructor = ImagePushButton;
ImagePushButton.superclass = DomletCtr.prototype;
function ImagePushButton( domId, imgNorm, imgNormMo, imgNormDisabled, imgPressMo, enabled, name, parent )
{
  ;
  if( domId ) 
  {
    this.init(domId, imgNorm, imgNormMo, imgNormDisabled, imgPressMo, enabled, name, parent);
  }
}
ImagePushButton.prototype.init = function( domId, imgNorm, imgNormMo, imgNormDisabled, imgPressMo, enabled, name,
                                           parent )
{
  ImagePushButton.superclass.init.call(this, domId, name, parent);
  ;
  this.state = {
    pressed : false,       
    highlighted : false,   
    images : {             
      normal : imgNorm,
      normalMousover : imgNormMo,
      normalDisabled : imgNormDisabled,
      pressedMouseover : imgPressMo
    }
  };
  if( !this.state.images.normalMouseover ) this.state.images.normalMouseover = this.state.images.normal;
  if( !this.state.images.normalDisabled ) this.state.images.normalDisabled = this.state.images.normal;
  if( !this.state.images.pressedMouseover ) this.state.images.pressedMouseover = this.state.images.normal;
  this.state.enabled = ((enabled == undefined) ? true : enabled);
  ;
  this.addDomlet(new Domlet(
          this.domId, 
          this.name, 
          this.parent, 
          new Array(
          'mouseout',
          'mouseover',
          'mousedown',
          'mouseup',
          'click'
          )
          ));
  this.activeCursor = this.domlets[this.name].getStyle('cursor');
  this.inactiveCursor = this.activeCursor;
  this.displayState(this.name);
  ;
} 
ImagePushButton.prototype.eventFromChild = function( childName, eventType )
{
  ;
  switch( eventType )
          {
    case "mouseover" :
      this.state.highlighted = true;
      this.displayState(this.name);
      break;
    case "mouseout" :
      var shouldDoUp = false;
      if( this.state.pressed == true )
        shouldDoUp = true;
      this.state.highlighted = false;
      this.state.pressed = false;
      this.displayState(this.name);
      if( shouldDoUp && this.upAction )
      {
        ;
        this.upAction.invoke();
      }
      break;
    case "mousedown" :
      this.state.pressed = true;
      this.displayState(this.name);
      if( this.downAction )
      {
        ;
        this.downAction.invoke();
      }
      break;
    case "mouseup" :
      this.state.pressed = false;
      this.displayState(this.name);
      if( this.upAction )
      {
        ;
        this.upAction.invoke();
      }
      break;
    case "click" :
      this.state.pressed = false;
      this.displayState(this.name);
      if( this.state.enabled )
      {
        if( this.buttonGroupManager )
          this.buttonGroupManager.buttonPushed(this);
        if( this.pressedAction )
        {
          ;
          this.pressedAction.invoke();
        }
      }
      break;
  }
} 
ImagePushButton.prototype.setPressedAction = function( action )
{
  this.pressedAction = action;
}
ImagePushButton.prototype.setDownAction = function( action )
{
  this.downAction = action;
}
ImagePushButton.prototype.setUpAction = function( action )
{
  this.upAction = action;
}
ImagePushButton.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, "setEnabled", false);
}
ImagePushButton.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, "setEnabled", true);
}
ImagePushButton.prototype.setEnabled = function( enabled )
{
  this.state.enabled = enabled;
  if( !enabled )
  {
    this.state.highlighted = false;
    this.state.down = false;
  }
  this.displayState(this.name);
}
ImagePushButton.prototype.displayState = function( domletName )
{
  var imgSrc;
  if( this.state.highlighted )
  {
    imgSrc = (this.state.pressed ? this.state.images.pressedMouseover : this.state.images.normalMousover);
  }
  else
  {
    imgSrc = this.state.images.normal;
  }
  if( !this.state.enabled ) 
  {
    imgSrc = this.state.images.normalDisabled;
    this.domlets[domletName].setStyle('cursor', this.inactiveCursor);
  }
  else
  {
    this.domlets[domletName].setStyle('cursor', this.activeCursor);
  }
  if( imgSrc != null ) 
  {
    ;
    this.domlets[domletName].setImageSource(imgSrc);
  }
} 
ImagePushButton.prototype.setActiveCursor = function( activeCursor )
{
  this.activeCursor = activeCursor;
  this.displayState(this.name);
}
ImagePushButton.prototype.setInactiveCursor = function( inactiveCursor )
{
  this.inactiveCursor = inactiveCursor;
  this.displayState(this.name);
}
ImagePushButton.prototype.setButtonGroupManager = function( buttonGroupManager )
{
  this.buttonGroupManager = buttonGroupManager;
}
