/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function SimpleInput(sId, sInputWidgetDomId, bOverwrite, bFocus)
{
	if (sId)
	{
		this.init(sId, sInputWidgetDomId, bOverwrite, bFocus);
	}
}
SimpleInput.prototype.init = function(sId, sInputWidgetDomId, bOverwrite, bFocus)
{
	;
	this.sId = sId;
	this.bOverwrite = bOverwrite;
	this.bFocus = bFocus;
	this.inputWidget = document.getElementById(sInputWidgetDomId);
	this.sInputWidgetDomId = sInputWidgetDomId;
	if (this.inputWidget == null)
	{
		;
	}
	else if (bFocus)
	{
		this.inputWidget.focus();
	}
}
SimpleInput.prototype.getId = function()
{
	////;
	return this.sId;
}
SimpleInput.prototype.getChar = function()
{
	;
	return this.inputWidget.value;
}
SimpleInput.prototype.addChar = function(sChar)
{
	;
	if (this.bFocus)
	{
		this.inputWidget.focus();
	}
	var nSelectionStart = this.inputWidget.selectionStart;
	var nSelectionEnd = this.inputWidget.selectionEnd;
	var sText = '';
	if (this.bOverwrite)
	{
		sText = sChar;
	}
	else
	{
		var sCurrentText = this.inputWidget.value;
		var sNewSelection = null;
		if (nSelectionStart)
		{
			sText = sCurrentText.substr(0, nSelectionStart);
			sText += sChar;
			sNewSelection = sText.length;
			sText += sCurrentText.substr(nSelectionEnd, sCurrentText.length);
		}
		else
		{
			sText = sChar;
			sNewSelection = sText.length;
		}
	}
	this.inputWidget.value = sText;
	this.inputWidget.selectionStart = sNewSelection;
	this.inputWidget.selectionEnd = sNewSelection;
	if (this.bFocus)
	{
		this.inputWidget.blur();
		this.inputWidget.focus();
	}
}
SimpleInput.prototype.getAddCharAction = function(sChar)
{
	if (sChar)
		return new ObjectMethodAction(this, "addChar", sChar);
	else
		return new ObjectMethodAction(this, "addChar");
}
SimpleInput.prototype.getGetCharAction = function()
{
	return new ObjectMethodAction(this, "getChar");
}
SimpleInput.prototype.getSetValueAction = function()
{
	return new ObjectMethodAction(this, "setValue");
}
SimpleInput.prototype.setValue = function(value)
{
	if (this.bFocus)
	{
		this.inputWidget.focus();
	}
	this.inputWidget.value = value;
	if (this.bFocus)
	{
		this.inputWidget.blur();
		this.inputWidget.focus();
	}
}
