 /*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>UniversalPushButton</DEPENDS>
</DEPENDENCIES>
*/
UniversalToggleButton.prototype             = new UniversalPushButton();
UniversalToggleButton.prototype.constructor = UniversalToggleButton;
UniversalToggleButton.superclass            = UniversalPushButton.prototype;
function UniversalToggleButton(domId, enabled, name, parent, initialPressed)
{
      ;
    if (domId) 
    {
        this.init(domId, enabled, name, parent, initialPressed);
    }
} 
UniversalToggleButton.prototype.setSuspend = function(suspend)
{
    this.state.suspend = suspend;
    this.buttonGroupManager = null;
}
UniversalToggleButton.prototype.init = function(domId, enabled, name, parent, initialPressed)
{
    UniversalToggleButton.superclass.init.call(this, domId, enabled, name, parent);
    this.state = {
        pressed : false,       
        highlighted : false   
    };
    this.state.enabled = ((enabled == undefined) ? true : enabled);
    this.state.suspend = false;
    this.initialPressed = ((initialPressed == undefined) ? false : initialPressed);
    this.broker = new Broker('toggleButtonBroker');
    ;
} 
UniversalToggleButton.prototype.setButtonGroupManager = function(buttonGroupManager)
{
    this.buttonGroupManager = buttonGroupManager;
}
UniversalToggleButton.prototype.setUnpressedAction = function(action)
{
    this.unpressedAction = action;
}
UniversalToggleButton.prototype.setSilentPressed = function(bPressed)
{
  ;
  if ( bPressed )
  {
    this.broker.getMessage("pressedAction");
  }
  else
  {
    this.broker.getMessage("normalAction");
  }
  this.state.pressed = bPressed;
}
UniversalToggleButton.prototype.getSetSilentPressedAction = function(bPressed)
{
    if (bPressed == undefined) bPressed = true;
    return new ObjectMethodAction(this, "setSilentPressed", bPressed);
}
UniversalToggleButton.prototype.getSetPressedAction = function(bPressed)
{
    if (bPressed == undefined) bPressed = true;
    return new ObjectMethodAction(this, "setPressed", bPressed);
}
UniversalToggleButton.prototype.getSetUnpressedAction = function()
{
    return new ObjectMethodAction(this, "setPressed", false);
}
UniversalToggleButton.prototype.getSetSilentUnpressedAction = function()
{
    return new ObjectMethodAction(this, "setSilentPressed", false);
}
UniversalToggleButton.prototype.setPressed = function(bPressed, fromManager)
{
  ;
  if (fromManager) 
  {
      ;
      if ( bPressed )
      {
        this.broker.getMessage("normalPressedAction");
        if (this.pressedAction)
        {
          this.pressedAction.invoke();
        }
      }
      else
      {
        this.broker.getMessage("normalAction");
        if (this.unpressedAction)
        {
            this.unpressedAction.invoke();
        }
      }
  }
  else
  {
      if ( bPressed )
      {
        this.broker.getMessage("mouseoverPressedAction");
        if (this.pressedAction)
        {
          this.pressedAction.invoke();
        }
      }
      else
      {
        this.broker.getMessage("mouseoverNormalAction");
        if (this.unpressedAction)
        {
            this.unpressedAction.invoke();
        }
      }
   }
  this.state.pressed = bPressed;
}
UniversalToggleButton.prototype.eventFromChild = function(childName, eventType)
{
    ;
    if (this.state.enabled && (this.broker != null) && !this.state.suspend)
    {
        switch(eventType)
        {
            case "mouseover" :
                if (this.state.pressed) this.broker.getMessage("mouseoverPressedAction");
                else  this.broker.getMessage("mouseoverNormalAction");
            break;
            case "mouseout" :
                if (this.state.pressed) this.broker.getMessage("pressedAction");
                else  this.broker.getMessage("normalAction");
            break;
            case "mousedown" :
                if (!this.state.pressed)
                {
                    this.broker.getMessage("mouseoverPressedAction");
                }
            break;
            case "mouseup" :
            break;
            case "click" :
                this.state.pressed = !this.state.pressed;
                if(this.state.pressed) 
                {
                    this.broker.getMessage("mouseoverPressedAction");
                    if (this.buttonGroupManager != null)
                        this.buttonGroupManager.buttonPressed(this);
                    if (this.pressedAction)
                        this.pressedAction.invoke();
                }
                else
                {
                    this.broker.getMessage("mouseoverNormalAction");
                    if (this.buttonGroupManager != null)
                        this.buttonGroupManager.buttonUnpressed(this);
                    if (this.unpressedAction)
                        this.unpressedAction.invoke();
                }
            break;
        }
    }
} 
UniversalToggleButton.prototype.start = function()
{
    if (this.initialPressed) this.setSilentPressed(true);
}
