/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>DataLoader</DEPENDS>
    <DEPENDS>Mode</DEPENDS>
</DEPENDENCIES>
*/
ClickMode.prototype = new Mode();
ClickMode.prototype.constructor = ClickMode;
ClickMode.superclass = Mode.prototype;
function ClickMode(sId, modeId)
{
	this.init(sId, modeId);
}
ClickMode.prototype.init = function(sId, modeId)
{
	ClickMode.superclass.init.call(this, sId, modeId);
	this.graphicsURl = "../graphics";
	this.graphicsDataURl = "../graphicsdata";
	this.imageValueAction = null;
	this.defaultImageValue = null;
}
ClickMode.prototype.dataChanged = function(aData)
{
	var width = this.manager.getViewWidth();
	var height = this.manager.getViewHeight();
	this.getModePane().style["height"] = height + "px";
	this.getModePane().style["width"] = width + "px";
	var url = this.graphicsURl;
	var params = "";
	params += "pageid=" + encodeURIComponent(this.manager.getPageId());
	params += this.modeParam;
	params += "&width=" + width;
	params += "&height=" + height;
	
	var now = new Date();
	params += "&uid=" + now.getTime();
	this.graphicurl = Browser.getRelativeURL(this.graphicsDataURl + "?" + params);
	
	var pageDocument = this.getPageDocument();
	var command = "";
	var first = true;
	
	for (var i = 0; i < aData.length; i++)
	{
		var element = aData[i];
		element.resolve(pageDocument);
		if (element.exists())
		{
			var pos = element.getPosition();
			command += "&ep=" + i + "," + pos.x + "," + pos.y;
		}
	}
	params += command;
	url = Browser.getRelativeURL(url);
	Browser.loadXMLDocumentPost(url, params, new ObjectMethodAction(this, "imageLoaded"),
			new ObjectMethodAction(this, "imageLoadedError"));
}
ClickMode.prototype.imageLoaded = function()
{
	if (this.imageValueAction == null)
	{
		
		this.getModePane().style["filter"] = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src=\"" + this.graphicurl + "\",sizingMethod=\"scale\")";
	}
	else
	{
		
		this.imageValueAction.invoke(this.graphicurl);
	}
	ClickMode.superclass.dataChanged.call(this);
}
ClickMode.prototype.imageLoadedError = function()
{
	alert("loadError");
	ClickMode.superclass.dataChanged.call(this);
}
ClickMode.prototype.cleanModePane = function()
{
	var modePane = this.getModePane();
	if (this.imageValueAction != null)
		this.imageValueAction.invoke(this.defaultImage);
	else
	{
		
		this.getModePane().style["filter"] = "filter:alpha(opacity=0)";
	}
}
ClickMode.prototype.registerImageValue = function(property, action, defaultImage)
{
	this.defaultImage = defaultImage;
	this.imageValueAction = action;
}
