/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>DataLoader</DEPENDS>
</DEPENDENCIES>
*/
function Mode(sId, modeId)
{
	this.init(sId, modeId);
}
Mode.prototype.init = function(sId, modeId)
{
	this.sId = sId;
	this.modeId = modeId;
	this.filter = null;
	this.mybroker = new Array();
	this.manager = null;
	this.modePaneDomId = null;
	this.modePane = null;
	this.uID = null;
	
	
	this.browse = true;
	this.active = false;
	this.baseURL = "../dataloader";
	this.modeParam = "&mode=" + modeId;
	this.loadCounter = 0;
}
Mode.prototype.getId = function()
{
	return this.sId;
}
Mode.prototype.getModeId = function()
{
	return this.modeId;
}
Mode.prototype.addBroker = function(broker)
{
	this.mybroker.push(broker);
	broker.addSetActiveHandle(new ObjectMethodAction(this, "setActive"));
	broker.addSetInActiveHandle(new ObjectMethodAction(this, "setInActive"));
	broker.addChangeModeDataHandle(new ObjectMethodAction(this, "changeModeData"));
}
Mode.prototype.setFilterController = function(filter)
{
	this.filter = filter;
	filter.setManager(this);
}
Mode.prototype.processFilterCommand = function(command)
{
	
}
Mode.prototype.setManager = function(manager)
{
	this.manager = manager;
}
Mode.prototype.getPageDocument = function()
{
	return this.manager.getPageDocument();
}
Mode.prototype.setModePane = function(domId)
{
	this.modePaneDomId = domId;
}
Mode.prototype.getModePane = function()
{
	if (this.modePane == null)
		this.modePane = Browser.getElementById(this.modePaneDomId);
	return this.modePane;
}
Mode.prototype.getModePaneDomId = function()
{
	return this.modePaneDomId;
}
Mode.prototype.hasModePane = function()
{
	return this.modePaneDomId != null;
}
Mode.prototype.setBrowse = function(browse)
{
	this.browse = browse;
	if (browse == true)
	{
		this.setModePaneVisible(false);
	}
	else
	{
		if (this.active == true)
		{
			this.setModePaneVisible(true);
			
			this.changeModeData();
		}
	}
}
Mode.prototype.setModePaneVisible = function(visible)
{
	if (this.hasModePane())
	{
		var style = "visible";
		if (visible == false)
			style = "hidden";
		this.getModePane().style["visibility"] = style;
	}
}
Mode.prototype.setActive = function()
{
	this.active = true;
	for (var i = 0; i < this.mybroker.length; i++)
		 var broker = this.mybroker[i].doActivated();
	this.manager.modeSetActive(this);
	if (this.browse == false)
	{
		this.setModePaneVisible(true);
		
		this.changeModeData();
	}
}
Mode.prototype.setInActive = function()
{
	this.active = false;
	this.setModePaneVisible(false);
	for (var i = 0; i < this.mybroker.length; i++)
		 var broker = this.mybroker[i].doInActivated();
}
Mode.prototype.isActive = function()
{
	return this.active;
}
Mode.prototype.reInit = function()
{
	
	if (this.hasModePane())
	{
		var width = this.manager.getViewWidth();
		var height = this.manager.getViewHeight();
		this.getModePane().style["height"] = height + "px";
		this.getModePane().style["width"] = width + "px";
	}
}
Mode.prototype.pageIdChanged = function()
{
	if (this.active == true && this.browse == false)
	{
		this.changeModeData();
	}
}
Mode.prototype.cleanModePane = function()
{
	
}
Mode.prototype.changeModeData = function()
{
	if (this.browse)
	{
		
		this.manager.setBrowseMode(false, this);
		this.cleanModePane();
		this.browse = false;
		this.setModePaneVisible(true);
		
		this.manager.browse();
	}
	else
	{
		if (this.manager.browseLocationChanged() == true)
		{
			
			this.manager.browse();
		}
		else
		{
			
			var tmpUID = this.createUID();
			if (this.uID != tmpUID)
			{
				this.uID = tmpUID;
				this.manager.aboutToLoadData();
				this.cleanModePane();
				this.doChangeModeData();
			}
		}
	}
}
Mode.prototype.createUID = function()
{
	return this.getRequestURL("uid", "uid");
}
Mode.prototype.doChangeModeData = function()
{
	this.loadCounter++;
	var callId = this.modeId + "call_" + this.loadCounter;
	var url = this.getRequestURL(this.baseURL, "targetjsid=" + callId);
	DataLoader.instance.load(url, new LoadDataCall(callId, this));
}
Mode.prototype.getRequestURL = function(baseURL, targetParam)
{
	var url = baseURL;
	url += "?pageid=" + encodeURIComponent(this.manager.getPageId());
	url += this.modeParam;
	if (targetParam != null && targetParam != undefined)
		url += "&" + targetParam;
	var commmonCommand = this.manager.getCommonCommand();
	if (commmonCommand != "")
		url += "&" + commmonCommand;
	var filterCommand = this.filter.getFilterCommand();
	if (filterCommand != "")
		url += "&" + filterCommand;
	return Browser.getRelativeURL(url);
}
Mode.prototype.dataChanged = function()
{
	this.manager.dataLoadingFinished();
}
LoadDataCall.prototype = new MethodCall();
LoadDataCall.prototype.constructor = LoadDataCall;
LoadDataCall.superclass = MethodCall.prototype;
function LoadDataCall(sId, manager)
{
	this.init(sId, manager);
}
LoadDataCall.prototype.init = function(sId, manager)
{
	LoadDataCall.superclass.init.call(this, sId, manager);
	this.data = new Array();
	this.dataById = new Array();
}
LoadDataCall.prototype.started = function()
{
}
LoadDataCall.prototype.addElementInfo = function(elementinfo)
{
	this.data.push(elementinfo);
	this.dataById[elementinfo.getId()] = elementinfo;
}
LoadDataCall.prototype.addValue = function(elementinfo, value)
{
	var info = this.dataById[elementinfo.getId()];
	info.addValue(value);
}
LoadDataCall.prototype.commit = function()
{
	this.manager.dataChanged(this.data);
}
