/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Answer</DEPENDS>
    <DEPENDS>Evaluation</DEPENDS>
    <DEPENDS>QuestionButtonWidget</DEPENDS>
    <DEPENDS>ObjectMethodAction</DEPENDS>
</DEPENDENCIES>
*/
CrossWordsManager.prototype             = new DomletCtr();
CrossWordsManager.prototype.constructor = CrossWordsManager;
CrossWordsManager.superclass            = DomletCtr.prototype;
function CrossWordsManager(sId, sCharacterWidgetTemplate, nX, nY )
{
  if (sId) { this.init(sId, sCharacterWidgetTemplate, nX, nY ); }
}
function GridPosContainer()
{
  //;
  this.cChar = null;
  this.sQuestionButton = null;
  this.oQestionButton = null;
  this.aCrossWordsWords = new Array();
  this.aLastEvaluations = new Array();
  this.oCharacterWidget = null;
  this.oTextGridAnswer = null;
}
CrossWordsManager.prototype.init = function(sId, sCharacterWidgetTemplate , nX, nY )
{
  //;
  this.sId = sId;
  this.workItem = null;
  this.nXOffset = 0;
  this.nYOffset = 0;
  this.sFgColorTip = null;
  this.sFgColorWrong = null;
  this.sFgColorCorrect = null;
  this.sBgColorTip = null;
  this.sBgColorWrong = null;
  this.sBgColorCorrect = null;
  this.sFgColorInactive = null;
  this.sBgColorInactive = null;
  this.sFgColorActive = null;
  this.sBgColorActive = null;
  this.oKeyboardBroker = null;
  this.bHasFocus = false;
  this.bDoBlurAfterUpdate = true;
  this.bEvaluating = false;
  this.aQuestionWidgets = new Array();
  this.aQuestionBrokers = new Array(); 
  this.oActiveCrossWordsWord = null; 
  this.oActiveCharacterWidget = null; 
  this.characterWidgetTemplate = document.getElementById(sCharacterWidgetTemplate);
  this.sCharacterWidgetTemplate = sCharacterWidgetTemplate;
  this.sBgColorInactive = this.characterWidgetTemplate.style.background;  
  this.sFgColorInactive = this.characterWidgetTemplate.style.color;  
  if (this.characterWidgetTemplate == null)
  {
    ;
  }
  this.trimTemplateNodeInput();
  this.aCrossWordsField = new Array();
  for( var x = 0; x < nX; x++)
  {
    this.aCrossWordsField[x] = new Array();
    for( var y = 0; y < nY; y++)
    {
      this.aCrossWordsField[x][y] = new GridPosContainer();
    }
  }
  this.nYOffset -= Math.ceil((( this.aCrossWordsField[0].length ) * ( parseInt(this.characterWidgetTemplate.style.height) + parseInt(this.characterWidgetTemplate.style.borderTopWidth) ) ) /2 );
  this.nXOffset -= Math.ceil((( this.aCrossWordsField.length ) * ( parseInt(this.characterWidgetTemplate.style.width) + parseInt(this.characterWidgetTemplate.style.borderLeftWidth) ) ) /2);
  this.nYOffset += Math.ceil(parseInt(this.characterWidgetTemplate.parentNode.style.height)  /2);
  this.nXOffset += Math.ceil(parseInt(this.characterWidgetTemplate.parentNode.style.width)  /2);
}
CrossWordsManager.prototype.getId = function()
{
  //;
  return this.sId;
}
CrossWordsManager.prototype.start = function()
{
  //;    
  Browser.removeNodeFromParent(this.characterWidgetTemplate);
  for(var i in this.aQuestionWidgets)
  {
    var sQuestionId = this.aQuestionWidgets[i].getQuestion().getId();
    if(this.aQuestionBrokers[sQuestionId])
    {
      var widgetQuestionBroker = this.aQuestionWidgets[i].getQuestionBroker();
      var masterQuestionBroker = this.aQuestionBrokers[sQuestionId];
      masterQuestionBroker.addFocusHandle(widgetQuestionBroker.getFocusAction());
      masterQuestionBroker.addBlurHandle(widgetQuestionBroker.getBlurAction());
    }
    else
    {
      ;
    }
  }
}
CrossWordsManager.prototype.trimTemplateNodeInput = function()
{
  var tmpInputNode = this.characterWidgetTemplate.getElementsByTagName('input')[0];
  if(!tmpInputNode)
  {
    ;
    tmpInputNode = document.createElement('input');
    this.characterWidgetTemplate.appendChild(tmpInputNode);
  }
  tmpInputNode.size = 10;
  tmpInputNode.maxlength = 1;
  tmpInputNode.value = '';
  tmpInputNode.style.border = 0;
}
CrossWordsManager.prototype.setWorkItem = function(oWorkItem)
{
  //;    
  this.workItem = oWorkItem;
}
CrossWordsManager.prototype.registerCrossWordsQuestionWidget = function(questionWidget)
{
  this.aQuestionWidgets.push(questionWidget);
}
CrossWordsManager.prototype.registerCrossWordsWord = function(oCrossWordsWord)
{
  //;
  var nX = oCrossWordsWord.nX;
  var nY = oCrossWordsWord.nY;  
  var sQuestionId = oCrossWordsWord.getQuestion().getId();
  if(this.aQuestionBrokers[sQuestionId])
  {
    ;
  }
  else
  {
    this.aQuestionBrokers[sQuestionId] = oCrossWordsWord.getQuestionBroker();
  }
  this.aCrossWordsField[nX][nY].sQuestionButton = oCrossWordsWord.getQuestionButtonWidgetDomId();
  this.aCrossWordsField[nX][nY].oCrossWordsWord = oCrossWordsWord;
  this.createQuestionButtonWidget(nX, nY);
  this.moveDomObjToGridPos(oCrossWordsWord.getQuestionButtonWidgetDomId(), nX, nY);
  if (oCrossWordsWord.getOrientationRight())
  {
    for( x = 0; x < oCrossWordsWord.sAnswer.length; x++)
    {
      if( this.aCrossWordsField[x+1+nX][nY].sQuestionButton || (this.aCrossWordsField[x+1+nX][nY].cChar && this.aCrossWordsField[x+1+nX][nY].cChar != oCrossWordsWord.sAnswer.charAt(x)))
      {
        ;
      }
      this.aCrossWordsField[x+1+nX][nY].cChar = oCrossWordsWord.sAnswer.charAt(x);
      this.aCrossWordsField[x+1+nX][nY].aCrossWordsWords.push( oCrossWordsWord);
      if ( this.aCrossWordsField[x+1+nX][nY].aCrossWordsWords.length == 1)
      {
        var sNewDomId = this.sId + '_row_' + nY + '_col_' + x+1+nX;
        var sNewInputDomId = this.sId + '_row_' + nY + '_col_' + x+1+nX + '_input';
        this.createCopyOfTemplateNode(sNewDomId, sNewInputDomId);
        this.createCharacterWidget( sNewDomId, sNewInputDomId, x+1+nX, nY);
        this.moveDomObjToGridPos(sNewDomId, x+1+nX, nY);
        this.createTextGridAnswer(x+1+nX, nY);
        this.addStatusChangeListener(x+1+nX, nY);
      }
      this.createEvaluation(oCrossWordsWord.getQuestion(), x+1+nX, nY);
    }
  }
  else
  {
    for( y = 0; y < oCrossWordsWord.sAnswer.length; y++)
    {
      if( this.aCrossWordsField[nX][y+1+nY].sQuestionButton || (this.aCrossWordsField[nX][y+1+nY].cChar && this.aCrossWordsField[nX][y+1+nY].cChar != oCrossWordsWord.sAnswer.charAt(y)))
      {
        ;
      }
      this.aCrossWordsField[nX][y+1+nY].cChar = oCrossWordsWord.sAnswer.charAt(y);
      this.aCrossWordsField[nX][y+1+nY].aCrossWordsWords.push(oCrossWordsWord);
      if (this.aCrossWordsField[nX][y+1+nY].aCrossWordsWords.length == 1 )
      {
        var sNewDomId = this.sId + '_row_' + y+1+nY + '_col_' + nX;
        var sNewInputDomId = this.sId + '_row_' + y+1+nY + '_col_' + nX + '_input';
        this.createCopyOfTemplateNode(sNewDomId, sNewInputDomId);
        this.createCharacterWidget( sNewDomId, sNewInputDomId, nX, y+1+nY);
        this.moveDomObjToGridPos(sNewDomId, nX, y+1+nY);
        this.createTextGridAnswer(nX, y+1+nY);
        this.addStatusChangeListener(nX, y+1+nY);
      }
      this.createEvaluation(oCrossWordsWord.getQuestion(), nX, y+1+nY);
    }
  }
  oCrossWordsWord.setManager(this);
}
CrossWordsManager.prototype.createCopyOfTemplateNode = function(sNewDomId, sNewInputDomId)
{
  //;
  var tmpNode = this.characterWidgetTemplate.cloneNode(true);
  tmpNode.id = sNewDomId;        
  var tmpInputNode = tmpNode.getElementsByTagName('input')[0];
  tmpInputNode.id = sNewInputDomId;
  this.characterWidgetTemplate.parentNode.appendChild(tmpNode);
}  
CrossWordsManager.prototype.moveDomObjToGridPos = function( sDomId, nX, nY)
{
  //;
  var tmpNode = Browser.getElementById(sDomId);
  var iTop = Browser.getPixelStyle(tmpNode, 'top');
  var iLeft = Browser.getPixelStyle(tmpNode, 'left');
  Browser.changePixelStyle(tmpNode, 'top', iTop + (nY * (parseInt(this.characterWidgetTemplate.style.height) + parseInt(this.characterWidgetTemplate.style.borderTopWidth))) + this.nYOffset);
  Browser.changePixelStyle(tmpNode, 'left', iLeft + (nX * (parseInt(this.characterWidgetTemplate.style.width ) + parseInt(this.characterWidgetTemplate.style.borderLeftWidth))) + this.nXOffset);
}
CrossWordsManager.prototype.createQuestionButtonWidget = function( nX, nY)
{
  //;
  tmpNode = Browser.getElementById(this.aCrossWordsField[nX][nY].sQuestionButton);
  this.aCrossWordsField[nX][nY].oQuestionButton = new QuestionButtonWidget(this.sId + '_row_' + nY + '_col_' + nX , this.aCrossWordsField[nX][nY].sQuestionButton, nX, nY);
  this.aCrossWordsField[nX][nY].oQuestionButton.setManager(this);
  this.aCrossWordsField[nX][nY].oCrossWordsWord.oQuestion.registerStatusChangeListener(this.aCrossWordsField[nX][nY].oQuestionButton);
  this.aCrossWordsField[nX][nY].oQuestionButton.setModelItem(this.aCrossWordsField[nX][nY].oCrossWordsWord.oQuestion);
  this.aCrossWordsField[nX][nY].oQuestionButton.setBroker(this.aCrossWordsField[nX][nY].oCrossWordsWord.getQuestionBroker());
  this.characterWidgetTemplate.parentNode.appendChild(tmpNode);
}
CrossWordsManager.prototype.createCharacterWidget = function( sWidgetDomId, sInputDomId, nX, nY)
{
  //;
  this.aCrossWordsField[nX][nY].oCharacterWidget = new CharacterWidget(this.sId + '_row_' + nY + '_col_' + nX, sWidgetDomId, sInputDomId, nX, nY);
  this.aCrossWordsField[nX][nY].oCharacterWidget.setManager(this);             
}
CrossWordsManager.prototype.createTextGridAnswer = function(nX, nY)
{
  //;
  var oTextGridAnswer = new TextGridAnswer('answer_' + this.sId + '_row_' + nY + '_col_' + nX ,10 ,  nX, nY, this.aCrossWordsField[nX][nY].cChar)
  this.workItem.registerAnswer(oTextGridAnswer);
  oTextGridAnswer.start();
  this.aCrossWordsField[nX][nY].oTextGridAnswer = oTextGridAnswer;    
}
CrossWordsManager.prototype.addStatusChangeListener = function(nX, nY)
{
  //;
  this.aCrossWordsField[nX][nY].aCrossWordsWords[0].oQuestion.registerStatusChangeListener(this.aCrossWordsField[nX][nY].oCharacterWidget);
  this.aCrossWordsField[nX][nY].oCharacterWidget.setModelItem(this.aCrossWordsField[nX][nY].oTextGridAnswer);
}
CrossWordsManager.prototype.createEvaluation = function(oQuestion,nX, nY ,bFalse)
{
  //;
  var nCorrect = 1;
  if (  bFalse )
  {
    nCorrect = 0;
  }
  var evaluation = new Evaluation( 'evaluation_' + '_col_' + nX + '_row_' + nY + '_' + oQuestion.getId() ,oQuestion, this.aCrossWordsField[nX][nY].oTextGridAnswer, nCorrect, nCorrect);
  this.workItem.registerEvaluation(evaluation);
  evaluation.start();
}        
CrossWordsManager.prototype.clickQuestionButtonWidget = function(oQuestionButtonWidget)
{
  //;
  var questionButtonWidgetDomId = oQuestionButtonWidget.getQuestionButtonWidgetDomId();
  var nX = oQuestionButtonWidget.getXPos();
  var nY = oQuestionButtonWidget.getYPos();
  if (this.oKeyboardBroker )
  {
    this.oKeyboardBroker.doGotFocus(this.sId);
  }
  else
  {
    ;
  }
  if(!(this.oActiveCrossWordsWord && oQuestionButtonWidget == this.oActiveCrossWordsWord.oQuestionButtonWidget))
  {
    if(this.oActiveCrossWordsWord)
    {
      this.oActiveCrossWordsWord.blur();
    }
    this.aCrossWordsField[nX][nY].oCrossWordsWord.focus();
    this.oActiveCrossWordsWord = this.aCrossWordsField[nX][nY].oCrossWordsWord;      
  }
  if(this.aCrossWordsField[nX][nY].oCrossWordsWord.getOrientationRight())
  {
    this.aCrossWordsField[nX+1][nY].oCharacterWidget.setFocus();
    this.oActiveCharacterWidget = this.aCrossWordsField[nX+1][nY].oCharacterWidget;
  }
  else if(this.aCrossWordsField[nX][nY].oCrossWordsWord.getOrientationDown())
  {
    this.aCrossWordsField[nX][nY+1].oCharacterWidget.setFocus();
    this.oActiveCharacterWidget = this.aCrossWordsField[nX][nY+1].oCharacterWidget;
  }
}
CrossWordsManager.prototype.clickCharacterWidget = function(oCharacterWidget)
{
  //;  
  this.oActiveCharacterWidget = oCharacterWidget;
  if (this.oKeyboardBroker )
  {
    this.oKeyboardBroker.doGotFocus(this.sId);
  }
  else
  {
    ;
  }
  var nX = oCharacterWidget.getXPos();
  var nY = oCharacterWidget.getYPos();
  oCharacterWidget.setFocus();
  if(this.oActiveCrossWordsWord)
  {
    this.oActiveCrossWordsWord.blur();
  }
  if(this.aCrossWordsField[nX][nY].aCrossWordsWords.length == 1)
  {
    this.oActiveCrossWordsWord = this.aCrossWordsField[nX][nY].aCrossWordsWords[0];
    this.oActiveCrossWordsWord.focus();
  }
  else
  {
    this.oActiveCrossWordsWord = null;
  }      
}
CrossWordsManager.prototype.assignText = function(oCharacterWidget, sChar)
{
  ;
  var nX = oCharacterWidget.nX;
  var nY = oCharacterWidget.nY;
  for( var i in this.aCrossWordsField[nX][nY].aCrossWordsWords)
  {
    var oAssignQuestion = null;
    oAssignQuestion = this.aCrossWordsField[nX][nY].aCrossWordsWords[i].oQuestion;
    var oAssignAnswer = null;
    var oAssignAnswer = this.workItem.getOrCreateAnswerByTextAndGridPos( sChar, nX, nY);
    var oAssignEvaluation = null;
    oAssignEvaluation = this.workItem.getOrCreateEvaluation(oAssignQuestion, oAssignAnswer);
    oAssignEvaluation.setActive(true);
    this.aCrossWordsField[nX][nY].aLastEvaluations.push(oAssignEvaluation);
    //  ;
  }
  if(this.oActiveCrossWordsWord)
  {
    if(this.oActiveCrossWordsWord.getOrientationRight())
    {
      if(nX < this.oActiveCrossWordsWord.nX + this.oActiveCrossWordsWord.sAnswer.length)
      {
        this.aCrossWordsField[nX+1][nY].oCharacterWidget.setFocus(); 
        this.oActiveCharacterWidget = this.aCrossWordsField[nX+1][nY].oCharacterWidget;
        if (this.oKeyboardBroker )
        {
          this.oKeyboardBroker.doGotFocus(this.sId);
        }
        else
        {
          //;
        }
      }
      else
      {
      }
    }
    else if(this.oActiveCrossWordsWord.getOrientationDown())
    {
      if(nY < this.oActiveCrossWordsWord.nY + this.oActiveCrossWordsWord.sAnswer.length)
      {
        if (this.oKeyboardBroker )
        {
          this.oKeyboardBroker.doGotFocus(this.sId);
        }
        else
        {
          ;
        }
        this.aCrossWordsField[nX][nY+1].oCharacterWidget.setFocus();  
        this.oActiveCharacterWidget = this.aCrossWordsField[nX][nY+1].oCharacterWidget;
      }
      else
      {
      }
    }
  }
}
CrossWordsManager.prototype.unAssignText = function(oCharacterWidget)
{
  ;
  var nX = oCharacterWidget.nX;
  var nY = oCharacterWidget.nY;
  while (this.aCrossWordsField[nX][nY].aLastEvaluations.length)
  {
    var oLastEvaluation = this.aCrossWordsField[nX][nY].aLastEvaluations.pop();
    if ( oLastEvaluation.isActive())
    {
      oLastEvaluation.setActive(false);
    }
  }
}
CrossWordsManager.prototype.setFocusByArrowKey = function(sArrowKey, oCharacterWidget)
{
  //;
  var nX = oCharacterWidget.getXPos();
  var nY = oCharacterWidget.getYPos();
  if ( sArrowKey ==  37 && nX > 1 && this.aCrossWordsField[nX-1][nY].oCharacterWidget)
  {
    this.clickCharacterWidget(this.aCrossWordsField[nX-1][nY].oCharacterWidget);
  }
  if ( sArrowKey ==  38 && nY > 1 && this.aCrossWordsField[nX][nY-1].oCharacterWidget)
  {
    this.clickCharacterWidget(this.aCrossWordsField[nX][nY-1].oCharacterWidget);
  }
  if ( sArrowKey ==  39 && nX < this.aCrossWordsField.length - 1 && this.aCrossWordsField[nX+1][nY].oCharacterWidget)
  {
    this.clickCharacterWidget(this.aCrossWordsField[nX+1][nY].oCharacterWidget);
  }
  if ( sArrowKey ==  40 && nY < this.aCrossWordsField[nX].length - 1 && this.aCrossWordsField[nX][nY+1].oCharacterWidget)
  {
    this.clickCharacterWidget(this.aCrossWordsField[nX][nY+1].oCharacterWidget);
  }
  if (this.oKeyboardBroker )
  {
    this.oKeyboardBroker.doGotFocus(this.sId);
  }
  else
  {
    ;
  }
}
CrossWordsManager.prototype.setBgColorInactive = function(sBgColorInactive)
{
  //;
  if(sBgColorInactive)
  {
    this.sBgColorInactive = sBgColorInactive;
  }
}
CrossWordsManager.prototype.setBgColorActive = function(sBgColorActive)
{
  //;
  if(sBgColorActive)
  {
    this.sBgColorActive = sBgColorActive;
  }
}
CrossWordsManager.prototype.setBgColorCorrect = function(sBgColorCorrect)
{
  //;
  if(sBgColorCorrect)
  {
    this.sBgColorCorrect = sBgColorCorrect;
  }
}
CrossWordsManager.prototype.setBgColorWrong = function(sBgColorWrong)
{
  //;
  if(sBgColorWrong)
  {
    this.sBgColorWrong = sBgColorWrong;
  }
}
CrossWordsManager.prototype.setBgColorTip = function(sBgColorTip)
{
  //;
  if(sBgColorTip)
  {
    this.sBgColorTip = sBgColorTip;
  }
}
CrossWordsManager.prototype.setFgColorInactive = function(sFgColorInactive)
{
  //;
  if(sFgColorInactive)
  {
    this.sFgColorInactive = sFgColorInactive;
  }
}
CrossWordsManager.prototype.setFgColorActive = function(sFgColorActive)
{
  //;
  if(sFgColorActive)
  {
    this.sFgColorActive = sFgColorActive;
  }
}
CrossWordsManager.prototype.setFgColorCorrect = function(sFgColorCorrect)
{
  //;
  if(sFgColorCorrect)
  {
    this.sFgColorCorrect = sFgColorCorrect;
  }
}
CrossWordsManager.prototype.setFgColorWrong = function(sFgColorWrong)
{
  //;
  if(sFgColorWrong)
  {
    this.sFgColorWrong = sFgColorWrong;
  }
}
CrossWordsManager.prototype.setFgColorTip = function(sFgColorTip)
{
  //;
  if(sFgColorTip)
  {
    this.sFgColorTip = sFgColorTip;
  }
}
CrossWordsManager.prototype.setKeyboardBroker = function(broker)
{
  ////;
  this.oKeyboardBroker = broker;
}
CrossWordsManager.prototype.addChar = function(sChar)
{
  ;
  if ( this.bHasFocus && this.oActiveCharacterWidget)
  { 
    this.unAssignText(this.oActiveCharacterWidget);
    this.assignText(this.oActiveCharacterWidget, sChar);
  }
}
CrossWordsManager.prototype.gotFocus = function(sFocusElementId)
{
  ;
  if( sFocusElementId == this.sId )
  {
    this.bHasFocus = true;
  }
  else
  {
    this.bHasFocus = false;
  }
}
CrossWordsManager.prototype.getGotFocusAction = function()
{
    return new ObjectMethodAction(this, "gotFocus");
}
CrossWordsManager.prototype.getAddCharAction = function(sChar)
{
    return new ObjectMethodAction(this, "addChar", sChar);
}
CrossWordsManager.prototype.colorizeDisplay = function()
{
  ;
}
CrossWordsManager.prototype.getEnableInputAction = function()
{
  return new ObjectMethodAction(this, 'setEnable', true);
}
CrossWordsManager.prototype.getDisableInputAction = function()
{
  return new ObjectMethodAction(this, 'setEnable', false);
}
CrossWordsManager.prototype.setEnable = function(bEnable)
{
  for( var x = 0; x < this.aCrossWordsField.length; x++)
  {
    for( var y = 0; y < this.aCrossWordsField[x].length; y++)
    {
      if(this.aCrossWordsField[x][y].oCharacterWidget)
      {
        if(bEnable)
        {
          this.aCrossWordsField[x][y].oCharacterWidget.enableInput();
        }
        else
        {
          this.aCrossWordsField[x][y].oCharacterWidget.disableInput();
        }
      }
    }
  }
}
