/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Dragable</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
Domino.prototype             = new Dragable();
Domino.prototype.constructor = Domino;
Domino.superclass            = Dragable.prototype;
function Domino(sId, sWidgetDomId, sWidgetAnswerDomId, sWidgetQuestionDomId, oAppendantQuestion)
{
  if (sId) { this.init(sId, sWidgetDomId, sWidgetAnswerDomId, sWidgetQuestionDomId, oAppendantQuestion); }
}
Domino.prototype.init = function(sId, sWidgetDomId, sWidgetAnswerDomId, sWidgetQuestionDomId, oAppendantQuestion)
{
  ;   
  this.sId = sId;
  this.modelItem = null;
  this.bIsBackwards = false;
  this.bIsVertical = true;
  this.dominoItemWidth = null;
  this.dominoItemHeight = null;
  this.listenToMouseEvents = true;
  this.sStylePosition = null;  
  this.dragWidget = null;  
  this.dragnDropManager = null;
  this.homePos = null;
  Domino.superclass.init.call(this, sId, sWidgetDomId);
  if(oAppendantQuestion)
  {
    this.oAppendantQuestion = oAppendantQuestion;
  }
  else
  {
    ;
  }
  this.widget = document.getElementById(sWidgetDomId);
  this.sWidgetDomId = sWidgetDomId;
  if (this.widget == null)
  {
    ;
  }
  this.widgetAnswer = document.getElementById(sWidgetAnswerDomId);
  this.sWidgetAnswerDomId = sWidgetAnswerDomId;
  if (this.widgetAnswer == null)
  {
    ;
  }
  this.widgetQuestion = document.getElementById(sWidgetQuestionDomId);
  this.sWidgetQuestionDomId = sWidgetQuestionDomId;
  if (this.widgetQuestion == null)
  {
    ;
  }
  this.addDomlet(new Domlet(
      this.sWidgetDomId,      
      this.sWidgetDomId,      
      this,                   
      new Array('click'))     
  )
  this.dragWidget = this.widget;  
  this.sStylePosition = this.dragWidget.style.position;
  this.dominoItemWidth = Browser.getPixelStyle(this.widgetAnswer, 'width');
  this.dominoItemHeight = Browser.getPixelStyle(this.widgetAnswer, 'height') + Browser.getPixelStyle(this.widgetQuestion, 'height');
  this.setVertical(false);
  this.setBackwards(false);
}
Domino.prototype.setHomePos = function(actualPoint)
{
  this.homePos = actualPoint;  
}
Domino.prototype.setHotSpot = function(pointHotSpot)
{
  this.nHotSpotX = pointHotSpot.x;
  this.nHotSpotY = pointHotSpot.y;  
}
Domino.prototype.setManager = function(oDominoManager)
{
  ;
  this.oDominoManager = oDominoManager;
  this.dragnDropManager = oDominoManager;
}
Domino.prototype.getId = function()
{
  ;
  return this.sId;
}
Domino.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
Domino.prototype.getModelItem = function()
{
  ;
  return this.modelItem;
}
Domino.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
 Domino.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {      
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else 
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':        
          if (this.broker) { this.broker.showSolution(); }
          break;
        default:
          this.oDominoManager.aActiveDominoItems.pop();
          this.oDominoManager.addDominoItemToContainer(this);
          this.listenToMouseEvents = true;
          if (this.broker) { this.broker.showUnassigned(); }                       
          break;
      }
    }    
    else if (nCount == 1)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
        case 'system_off':
          this.setHomePos(this.oDominoManager.getDominoItemSnapPoint(this));
          this.moveToHomePosition();
          this.listenToMouseEvents = false;
          if (this.broker) { this.broker.showAssigned(); }
          break;
        case 'system_set':
          this.setHomePos(this.oDominoManager.getDominoItemSnapPoint(this));
          this.moveToHomePosition();
          this.listenToMouseEvents = false;
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_solution':
          this.setHomePos(this.oDominoManager.getDominoItemSnapPoint(this));
          this.moveToHomePosition();
          this.listenToMouseEvents = false;
          if (this.broker) { this.broker.showSolution(); }
          break;
        case 'system_approve':          
          if (this.broker) { this.broker.showTipApproveCorrect(); }
          break;
        case 'system_brand':  
          break;          
      }
    }
    else
    {
      ;
    }
  }
}
Domino.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "mousedown" :
      ;
      if(this.listenToMouseEvents)
      {
        this.mouseDownHandler(domlet, event);
      }
      break;
    case "mouseup" :
      ;
      break;
    case "mouseover" :
      ;
      break;
    case "mouseout" :
      ;
      break;
    case "mousemove" :
      //;
      break;
    case "click" :
      ;
      if(this.listenToMouseEvents)
      {
        this.clickHandler(domlet, event);
      }      
      break;
  }
} 
Domino.prototype.clickHandler = function(domlet, event)
{
  ;
  this.oDominoManager.click(this);
}
Domino.prototype.setBackwards = function ( bSetBackwards )
{
  ; 
  var point1 = new Point(0,0);  
  var point2 = new Point(0,0);
  if( bSetBackwards )
  {
    if ( ! this.bIsBackwards )
    {
      Browser.getAbsPos(this.widgetAnswer , point1);
      Browser.getAbsPos(this.widgetQuestion, point2);
      Browser.moveTo(this.widgetAnswer, point2);
      Browser.moveTo(this.widgetQuestion, point1);
      this.bIsBackwards = true;
    }
  }
  else
  {
    if ( this.bIsBackwards )
    {
      Browser.getAbsPos( this.widgetAnswer, point1);
      Browser.getAbsPos( this.widgetQuestion, point2);
      Browser.moveTo(this.widgetAnswer, point2);
      Browser.moveTo(this.widgetQuestion, point1);
      this.bIsBackwards = false ;
    }
  }
}
Domino.prototype.setVertical = function ( bSetVertical )
{ 
  ; 
  var pointA = new Point(0,0);  
  var pointQ = new Point(0,0);
  if( bSetVertical )
  {
    if ( ! this.bIsVertical )
    {
      Browser.getAbsPos(this.widgetAnswer, pointA);
      Browser.getAbsPos(this.widgetQuestion , pointQ);
      if ( pointA.x > pointQ.x )
      { 
        Browser.moveTo(this.widgetAnswer, new Point( pointQ.x , (pointQ.y + this.dominoItemHeight)));
      }
      else
      {
        Browser.moveTo(this.widgetQuestion, new Point( pointA.x , (pointA.y + this.dominoItemHeight)));
      }
      this.dominoItemWidth = Browser.getPixelStyle(this.widgetAnswer, 'width');
      this.dominoItemHeight = Browser.getPixelStyle(this.widgetAnswer, 'height') + Browser.getPixelStyle(this.widgetQuestion, 'height');
      this.bIsVertical = true;
    }  
  }
  else
  {
    if ( this.bIsVertical )
    {
      Browser.getAbsPos( this.widgetAnswer, pointA);
      Browser.getAbsPos( this.widgetQuestion, pointQ);
      if ( pointA.y > pointQ.y )
      { 
        Browser.moveTo(this.widgetAnswer, new Point( (pointQ.x + this.dominoItemWidth) , pointQ.y));
      }
      else
      {
        Browser.moveTo(this.widgetQuestion, new Point( (pointA.x + this.dominoItemWidth) , pointA.y));
      }
      this.dominoItemWidth = Browser.getPixelStyle(this.widgetAnswer, 'width') + Browser.getPixelStyle(this.widgetQuestion, 'width');
      this.dominoItemHeight = Browser.getPixelStyle(this.widgetAnswer, 'height'); 
      this.bIsVertical = false ;
    }
  }
}
