/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DropTarget</DEPENDS>
</DEPENDENCIES>
*/
MatcherDropTarget.prototype             = new DropTarget();
MatcherDropTarget.prototype.constructor = MatcherDropTarget;
MatcherDropTarget.superclass            = DropTarget.prototype;
function MatcherDropTarget(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY)
{
  if (sId) { this.init(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY); }
}
MatcherDropTarget.prototype.init = function(sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY)
{
  ;
  MatcherDropTarget.superclass.init.call(this, sId, sWidgetDomId, sAreaDomId, nSnapX, nSnapY);
  this.viewManager = null;
  this.valueItem = null;
  this.showUnassignedAction = null;
  this.showAssignedAction = null;
  this.showTipAssignedAction = null;
  this.showCorrectAction = null;
  this.showWrongAction = null;
}
MatcherDropTarget.prototype.setByModel = function(model)
{
  ;
  if (model.getValue() != '')
  {
    if (model.getOrigin() == 'user')
    {
      if (this.showAssignedAction) { this.showAssignedAction.invoke(); }
    }
    else if (model.getOrigin() == 'system')
    {
      if (this.showTipAssignedAction) { this.showTipAssignedAction.invoke(); }
    }
    else
    {
      ;
      if (this.showUnassignedAction) { this.showUnassignedAction.invoke(); }
    }
  }
  else
  {
    if (this.showUnassignedAction) { this.showUnassignedAction.invoke(); }
  }
}
MatcherDropTarget.prototype.setBySolution = function(model)
{
  ;
  var solution = this.valueItem.getSolution();
  if (solution == '')
  {
    if (this.showUnassignedAction) { this.showUnassignedAction.invoke(); }
  }
  else
  {
    if (this.showAssignedAction) { this.showAssignedAction.invoke(); }
  }
}
MatcherDropTarget.prototype.changed = function(model)
{
  ;
  this.setByModel(model);
}
MatcherDropTarget.prototype.registerViewManager = function(viewManager)
{
  ;
  this.viewManager = viewManager;
}
MatcherDropTarget.prototype.evaluate = function()
{
  ;
  if (this.valueItem.isSolved())
  {
    if (this.showCorrectAction) { this.showCorrectAction.invoke(); }
  }
  else
  {
    if (this.showWrongAction) { this.showWrongAction.invoke(); }
  }
}
MatcherDropTarget.prototype.drop = function(oDragable)
{
  ;
  var bDropped = true;
  var sId = oDragable.optionItem.getId();
  this.valueItem.setValueByUser(sId);
  if (this.valueItem.getValue() != sId)
  {
    ;
    bDropped = false;
  }
  oDragable.drop(this, bDropped);
}
MatcherDropTarget.prototype.lift = function(oDragable)
{
  ;
  this.valueItem.setValueByUser('');
  oDragable.lift(this);
}
MatcherDropTarget.prototype.showSolution = function()
{
  ;
  this.setBySolution(this.valueItem);
}
MatcherDropTarget.prototype.hideSolution = function()
{
  ;
  this.setByModel(this.valueItem);
}
MatcherDropTarget.prototype.setShowAssignedAction = function(action)
{
  ;
  this.showAssignedAction = action;
}
MatcherDropTarget.prototype.setShowUnassignedAction = function(action)
{
  ;
  this.showUnassignedAction = action;
}
MatcherDropTarget.prototype.setShowTipAssignedAction = function(action)
{
  ;
  this.showTipAssignedAction = action;
}
MatcherDropTarget.prototype.setShowCorrectAction = function(action)
{
  ;
  this.showCorrectAction = action;
}
MatcherDropTarget.prototype.setShowWrongAction = function(action)
{
  ;
  this.showWrongAction = action;
}
