/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
DelayEvent.prototype = new Broker();
DelayEvent.prototype.constructor = DelayEvent;
DelayEvent.superclass = Broker.prototype;
function DelayEvent(sId, delay)
{
	if (sId)
	{
		this.init(sId, delay);
	}
}
DelayEvent.prototype.init = function(sId, delay)
{
	this.sId = sId;
	this.delay = delay;
	this.running = false;
	DelayEventMap.instance.addDelayEvent(this);
	DelayEvent.superclass.init.call(this, "DelayEvent");
}
DelayEvent.prototype.getId = function()
{
	return this.sId;
}
DelayEvent.prototype.getStartAction = function()
{
	return new ObjectMethodAction(this, "start");
}
DelayEvent.prototype.start = function()
{
	if (this.running == false)
	{
		this.running = true;
		window.setTimeout("DelayEventMap.instance.getDelayEvent(\'" + this.sId + "\').delayed()", this.delay);
	}
}
DelayEvent.prototype.delayed = function()
{
	if (this.running == true)
	{
		this.getMessage("started");
	}
}
DelayEvent.prototype.getStopAction = function()
{
	return new ObjectMethodAction(this, "stop");
}
DelayEvent.prototype.stop = function()
{
	if (this.running == true)
	{
		this.running = false;
		this.getMessage("stopped");
	}
}
DelayEvent.prototype.addStartedHandle = function(action)
{
	this.registerAction("started", action);
}
DelayEvent.prototype.addStoppedHandle = function(action)
{
	this.registerAction("stopped", action);
}
function DelayEventMap()
{
	this.delayEvents = new Array();
}
DelayEventMap.instance = new DelayEventMap();
DelayEventMap.prototype.addDelayEvent = function(delayEvent)
{
	this.delayEvents[delayEvent.getId()] = delayEvent;
}
DelayEventMap.prototype.getDelayEvent = function(sId)
{
	return this.delayEvents[sId];
}
