/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Product</DEPENDS>
    <DEPENDS>ProductComparison</DEPENDS>
    <DEPENDS>ProductFinder</DEPENDS>
    <DEPENDS>ProductWastebin</DEPENDS>
</DEPENDENCIES>
*/
function ProductManagerMain(sId, initialSize)
{
	if (sId)
	{
		this.init(sId, initialSize);
	}
}
ProductManagerMain.prototype.init = function(sId)
{
	;
	this.sId = sId;
	this.products = new Array();
	this.productManager = new Array();
}
ProductManagerMain.prototype.getId = function()
{
	return this.sId;
}
ProductManagerMain.prototype.registerComparison = function(comparison)
{
	;
	this.comparison = comparison;
	this.comparison.setMainManager(this);
	this.productManager[comparison.getManagerName()] = this.comparison;
}
ProductManagerMain.prototype.registerFinder = function(finder)
{
	;
	this.finder = finder;
	this.finder.setMainManager(this);
	this.productManager[finder.getManagerName()] = this.finder;
}
ProductManagerMain.prototype.registerWastebin = function(wastebin)
{
	;
	this.wastebin = wastebin;
	this.wastebin.setMainManager(this);
	this.productManager[wastebin.getManagerName()] = this.wastebin;
}
ProductManagerMain.prototype.registerDragable = function(dragable)
{
	;
	this.dragable = dragable;
	this.dragable.setMainManager(this);
	this.productManager[dragable.getManagerName()] = this.dragable;
}
ProductManagerMain.prototype.start = function()
{
}
ProductManagerMain.prototype.pushProduct = function(origin, product)
{
	
	if (this.finder.isInScope(product))
	{
		this.finder.assign(product);
	}
}
ProductManagerMain.prototype.addInitialProduct = function(product)
{
	if (product != null)
		this.products[product.getProductId()] = product;
}
ProductManagerMain.prototype.getProduct = function(productId)
{
	var product = this.products[productId];
	if (product == null)
	{
		product = new Product(productId, productId, false);
		this.products[productId] = product;
	}
	return product;
}
ProductManagerMain.prototype.isProductAssignedToOther = function(managerName, productId)
{
	for (var i in this.productManager)
	{
		if (managerName != i && this.productManager[i].isOwner(productId))
			return true;
	}
	return false;
}
ProductManagerMain.prototype.getAssignedManager = function(productId)
{
	for (var i in this.productManager)
	{
		if (this.productManager[i].isOwner(productId))
			return this.productManager[i];
	}
	return null;
}
ProductManagerMain.prototype.startDragAndDrop = function(product, position, event)
{
	var oldOwner = this.getAssignedManager(product.getProductId());
	this.dragable.setModelItem(product);
	this.dragable.moveToSnapPosition(position);
	this.dragable.setVisible(true);
	this.dragable.beginDragFromOutside(event);
	oldOwner.unassign(product);
}
ProductManagerMain.prototype.abortDragAndDrop = function(product)
{
	
	if (this.finder.isInScope(product))
		this.finder.assign(product);
}
