/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>Point</DEPENDS>
</DEPENDENCIES>
*/
Queue.prototype             = new DomletCtr();
Queue.prototype.constructor = Queue;
Queue.superclass            = DomletCtr.prototype;
function Queue(sId, sWidgetInputDomId, sFgColorTip, sFgColorWrong, sFgColorCorrect, bAutosize)
{
  if (sId) { this.init(sId, sWidgetInputDomId,  sFgColorTip, sFgColorWrong, sFgColorCorrect, bAutosize); }
}
Queue.prototype.init = function(sId, sWidgetInputDomId,  sFgColorTip, sFgColorWrong, sFgColorCorrect, bAutosize)
{
  ;
  this.sId = sId;
  this.modelItem = null;
  this.broker = null;
  this.aAnswers = new Array();
  this.bEnabled = true;
  this.bAutosize = bAutosize;
  this.nAdditionalPixels = null;
  this.unassignedValue = null;
  this.sFgColorTip = null;
  this.sFgColorWrong = null;
  this.sFgColorTip = null;
  this.nCursorPos = null;
  this.sFgInactiveColor = null;
  this.nAdditionalPixels = 0;
  if(sFgColorTip)
  {
    this.sFgColorTip = sFgColorTip;
  }
  if(sFgColorWrong)
  {
      this.sFgColorWrong = sFgColorWrong;
  }
  if(sFgColorCorrect)
  {
      this.sFgColorCorrect = sFgColorCorrect;
  }
  Queue.superclass.init.call(this, sWidgetInputDomId, sId, this);
  this.widgetInput = document.getElementById(sWidgetInputDomId);
  this.sWidgetInputDomId = sWidgetInputDomId;
  if (this.widgetInput == null)
  {
    ;
  }
  this.widgetInput.selectionEnd = 0;
  this.widgetInput.selectionStart = 0;
  this.addDomlet(new Domlet(
    this.sWidgetInputDomId,      
    this.sWidgetInputDomId,      
    this,                   
    new Array('keypress', 'select', 'blur', 'focus')) 
  )
  this.sFgInactiveColor = Browser.getComputedStyleById(this.sWidgetInputDomId, 'color');
}
Queue.prototype.getId = function()
{
  return this.sId;
}
Queue.prototype.setAutosize = function(bAutosize)
{
  this.bAutosize = bAutosize;
}
Queue.prototype.setAdditionalPixels = function(nAdditionalPixels)
{
  this.nAdditionalPixels = nAdditionalPixels;
}
Queue.prototype.start = function()
{
  //;
  this.unassignedValue = this.widgetInput.value;
  if ( this.unassignedValue )
  {
    var tmpString = new String();
    for ( var i = 0; i < this.unassignedValue.length; i++)
    {
        if ( this.unassignedValue.charAt(i) != ' ' && this.unassignedValue.charAt(i) != '\n')
        {
           tmpString += this.unassignedValue.charAt(i);
        }
    }
    this.unassignedValue  =  tmpString;
  }
  if ( this.bAutosize )
  {
    this.widgetInput.style.visibility = 'hidden';
    this.widgetInput.value = this.modelItem.getSolutionComplement().getText();
    Browser.changePixelStyle(this.widgetInput, 'width', this.widgetInput.value.length * 2);
    var i = 0;
    while( this.widgetInput.scrollHeight > this.widgetInput.clientHeight  && i < 1000) 
    {
      i++;
      var width = Browser.getPixelStyle(this.widgetInput, 'width');
      Browser.changePixelStyle(this.widgetInput, 'width', width + 10);
    }
    this.widgetInput.value = this.unassignedValue;
    this.widgetInput.style.visibility = 'inherit';
    var width = Browser.getPixelStyle(this.widgetInput, 'width');
    Browser.changePixelStyle(this.widgetInput, 'width', width + this.nAdditionalPixels);
  }
  this.widgetInput.value = this.unassignedValue;
  if(!this.bAlreadyStarted)
  {
    var notifyFlagBackup = this.modelItem.workItem.getNotifyManagers();
    this.modelItem.workItem.bNotifyManagers = false;
    this.assignText(false);
    this.modelItem.workItem.setNotifyManagers(notifyFlagBackup);
    this.bAlreadyStarted = true;
  }
}
Queue.prototype.setModelItem = function(modelItem)
{
  ;
  this.modelItem = modelItem;
}
Queue.prototype.addAnswer = function(answer)
{
  ;
  this.aAnswers[answer.getId()] = answer;
}
Queue.prototype.getModelItem = function()
{
  return this.modelItem;
}
Queue.prototype.setBroker = function(broker)
{
  ;
  this.broker = broker;
}
Queue.prototype.changed = function(model)
{
  ;
  if (model.isEvaluated())
  {
    if (model.isSolved() == true)
    {
      this.widgetInput.style.color = this.sFgColorCorrect;
      if (this.broker) { this.broker.showCorrect(); }
    }
    else if (model.isSolved() == false)
    {
      if (model.getEvaluation())
      {
        this.widgetInput.style.color = this.sFgColorWrong;
      }
      if (this.broker) { this.broker.showWrong(); }
    }
    else
    {
    }
  }
  else
  {
    var nCount = model.countActiveEvaluations();
    if (nCount == 0)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'system_solution':
          break;
        default:
          this.widgetInput.value = this.unassignedValue;
          this.assignText();
          if (this.broker) { this.broker.showUnassigned(); }
      }
    }
    else if (nCount == 1)
    {
      switch (model.getEvaluation().getOrigin())
      {
        case 'user':
          if (model.getEvaluation().isActive())
          {
            var sText = model.getEvaluation().getAnswer().getText();
            this.widgetInput.value = sText;
            this.widgetInput.selectionStart = this.nCursorPos;
            this.widgetInput.selectionEnd = this.nCursorPos;
            this.widgetInput.style.color = this.sFgInactiveColor;
            if (this.broker) { this.broker.showAssigned(); }
          }
          break;
        case 'system_approve':
          ;
        case 'system_set':
          var sText = model.getEvaluation().getAnswer().getText();
          this.widgetInput.value = sText;
          this.widgetInput.selectionStart = this.nCursorPos;
          this.widgetInput.selectionEnd = this.nCursorPos;
          this.widgetInput.style.color = this.sFgColorTip;
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_solution':
          if ( model.getEvaluation().isActive() )
          {
            var sText = model.getEvaluation().getAnswer().getText();
            this.widgetInput.value = sText;
            this.widgetInput.selectionStart = this.nCursorPos;
            this.widgetInput.selectionEnd = this.nCursorPos;
            this.widgetInput.style.color = this.sFgColorTip;
            if (this.broker) { this.broker.showSolution(); }
          }
          break;
        case 'system_setpartial':
          var sText = model.getEvaluation().getAnswer().getText();
          this.widgetInput.value = sText;
          this.widgetInput.selectionStart = this.nCursorPos;
          this.widgetInput.selectionEnd = this.nCursorPos;
          this.widgetInput.style.color = this.sFgColorTip;
          if (this.broker) { this.broker.showTipAssigned(); }
          break;
        case 'system_brand':
          this.widgetInput.style.color = this.sFgColorWrong;
          if (this.broker) { this.broker.showTipBrandWrong(); }
          break;
      }
    }
    else
    {
      ;
    }
  }
}
Queue.prototype.eventFromChild = function(childName, eventType, event)
{
  //;
  if(!this.bEnabled)
  {
    Browser.eventPreventDefault(event);
    return;
  }
  var domlet = this.domlets[childName];
  switch(eventType)
  {
    case "blur" :
      //;
      this.blurHandler(domlet, event);
      break;
   case "keypress" :
      //;
      this.keypressHandler(domlet, event);
      break;
   case "select" :
      //;
      this.mousedownHandler(domlet, event);
      break;
   case "focus" :
      this.focusHandler(domlet, event);
      break;
  }
}
Queue.prototype.blurHandler = function(domlet, event)
{
  //;
  this.assignText();
}
Queue.prototype.mousedownHandler = function(domlet, event)
{
  //;
  if ( this.modelItem )
  {
    this.modelItem.workItem.setUserFocus(this.modelItem);
  }
  this.widgetInput.selectionStart =  this.widgetInput.selectionEnd;
}
Queue.prototype.focusHandler = function(domlet, event)
{
  //;
  if ( this.modelItem )
  {
    this.modelItem.workItem.setUserFocus(this.modelItem);
  }
  this.assignText(true);
}
Queue.prototype.keypressHandler = function(domlet, event)
{
  //;
  var bValidKey = false;
  var bSelection = false;
  var sInputString = new String()
  var sInputString = this.widgetInput.value;
  var nCursor = 0;
  nCursor = this.widgetInput.selectionEnd;
  if ( this.widgetInput.selectionEnd != this.widgetInput.selectionStart)
  {
    bSelection = true;
  }
  this.widgetInput.selectionStart =  this.widgetInput.selectionEnd;
  if ( event.which == 32 )
  {
    ;
    bValidKey = true;
    if ( nCursor < 1 || sInputString[nCursor - 1] == ' ')
    { 
      bValidKey = false;
    }
    if ( sInputString.length-1 < nCursor || sInputString[nCursor] == ' ')
    { 
      bValidKey = false;
    }
  }
  if (event.which == 8)
  {
    ;
    if ( sInputString.length > nCursor && sInputString[nCursor - 1] == ' ')
    { 
      bValidKey = true;
    }    
  }
  if (event.keyCode == 46)
  { 
    ;
    if ( nCursor >= 1 && sInputString[nCursor] == ' ')
    { 
      bValidKey = true;
    }
  }
  if (event.keyCode == 35 || event.keyCode == 36 )
  {
    ;
    bValidKey = true;
  }
  if (event.keyCode == 37 || event.keyCode == 38 || event.keyCode == 39 || event.keyCode == 40)
  {
    ;
    bValidKey = true;
  }
  if ( bValidKey && ! bSelection)
  {
  }
  else
  {
    event.preventDefault();  
  }
}
Queue.prototype.assignText = function(bConfirmActive)
{
  ;
  var answer = null;
  this.nCursorPos = this.widgetInput.selectionEnd;
  var sText = this.widgetInput.value
  for (var id in this.aAnswers)
  {
    if (this.aAnswers[id].getText() == sText)
    {
      answer = this.aAnswers[id];
      break;
    }
  }
  if (answer)
  {
    this.modelItem.assign(this.modelItem, answer);
  }
  else
  {
    if(bConfirmActive)
    {
      this.modelItem.assignOrConfirmByText(this.modelItem, sText);
    }
    else
    {
      this.modelItem.assignByText(this.modelItem, sText);
    }
  }
}
Queue.prototype.setFgColorTip = function(sFgColorTip)
{
  this.sFgColorTip = sFgColorTip;
}
Queue.prototype.setFgColorWrong = function(sFgColorWrong)
{
  this.sFgColorWrong = sFgColorWrong;
}
Queue.prototype.setFgColorCorrect = function(sFgColorCorrect)
{
  this.sFgColorCorrect = sFgColorCorrect;
}
Queue.prototype.enable = function(bEnable)
{
  this.bEnabled = bEnable;
}
Queue.prototype.getEnableAction = function()
{
  return new ObjectMethodAction(this, 'enable', true);
}
Queue.prototype.getDisableAction = function()
{
  return new ObjectMethodAction(this, 'enable', false);
}
