/*
 <DEPENDENCIES>
	 <DEPENDS>Browser</DEPENDS>
	 <DEPENDS>Logger</DEPENDS>
	 <DEPENDS>ServiceRegistryAccessor</DEPENDS>
 </DEPENDENCIES>
 */
function AchievementStatistic(structureName, contentidentifier, trace, scorestatistics)
{
	if (scorestatistics != undefined)
	{
   		this.scorestatistics = scorestatistics;
	}
	else
	{
		this.scorestatistics = null;
		this.trace = trace;
		this.init(structureName, contentidentifier);
	}
}
AchievementStatistic.prototype.init = function(structureName, contentidentifier)
{
	;
	var achievementservice = null;
	var serviceregistry = ServiceRegistryAccess.getServiceRegistry();
	if (serviceregistry)
		achievementservice = serviceregistry.getService("achievementservice");
	if (achievementservice)
	{
		if (this.trace)
			this.scorestatistics = achievementservice.getScoreStatisticsTrace(structureName, contentidentifier);
		else
			this.scorestatistics = achievementservice.getScoreStatisticsTrack(structureName, contentidentifier);
	}
} 
AchievementStatistic.prototype.getScoreStatistics = function()
{
	return this.scorestatistics;
}
AchievementStatistic.prototype.parseFormula = function(formula)
{
	if (!this.scorestatisticsvalues)
	{
		
		;
		this.scorestatisticsvalues = new Array();
		this.scorestatisticsvalues["\\[scorestatistics.fractionCorrect\\]"] = this.scorestatistics.getFractionCorrect();
		this.scorestatisticsvalues["\\[scorestatistics.fractionCorrectWithHelp\\]"] = this.scorestatistics.getFractionCorrectWithHelp();
		this.scorestatisticsvalues["\\[scorestatistics.fractionWrong\\]"] = this.scorestatistics.getFractionWrong();
		this.scorestatisticsvalues["\\[scorestatistics.fractionDone\\]"] = this.scorestatistics.getFractionDone();
		this.scorestatisticsvalues["\\[scorestatistics.fractionUndone\\]"] = this.scorestatistics.getFractionUndone();
	}
	for (var param in this.scorestatisticsvalues)
	{
		while (formula.search(param) > -1)
		{
			formula = formula.replace(new RegExp(param), this.scorestatisticsvalues[param]);
		}
	}
	return formula;
}
