/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>Controller</DEPENDS>
    <DEPENDS>DomletCtr</DEPENDS>
    <DEPENDS>Domlet</DEPENDS>
    <DEPENDS>QeaWorkItem</DEPENDS>
</DEPENDENCIES>
*/
DominoWorkItem.prototype             = new QeaWorkItem();
DominoWorkItem.prototype.constructor = DominoWorkItem;
DominoWorkItem.superclass            = QeaWorkItem.prototype;
function DominoWorkItem(sId) 
{
  if (sId) { this.init(sId); }
}
DominoWorkItem.prototype.init = function(sId)
{
  this.lastEvaluation = null;
  this.firstEvaluation = null;
  this.evaluateRequested = false;
  DominoWorkItem.superclass.init.call(this, sId);
}
DominoWorkItem.prototype.showSolution = function() 
{
  ;
  this.setUndoBreak('system_solution_sentinel');
  this.bNotifyManagers = false;
  var bFirstFound = false;
  for (var id in this.aEvaluations)
  {
    var e = this.aEvaluations[id];
    if (e == this.firstEvaluation)
    {
      bFirstFound = true;
    }
    if ( bFirstFound )
    {
      e.bEvaluated = false;
      if (e.isSolution())
      {
        if (e.isActive())
        {
        }
        else
        {
          e.setActive(true, 'system_solution');
        }      
      }
    }
  }
  for (var id in this.aEvaluations)
  {
    var e = this.aEvaluations[id];
    if (e == this.firstEvaluation)
    {
      bFirstFound = false;
    }
    if ( bFirstFound )
    {
      e.bEvaluated = false;
      if (e.isSolution())
      {
        if (e.isActive())
        {
        }
        else
        {
          e.setActive(true, 'system_solution');
        }      
      }
    }
  }
  this.bNotifyManagers = true;
  this.changed();
}
DominoWorkItem.prototype.changed = function(evaluation)
{
  ;
  if ( ! this.firstEvaluation)
  {
    this.firstEvaluation = evaluation;
  }
  DominoWorkItem.superclass.changed.call(this, evaluation);
}
DominoWorkItem.prototype.propagateStatus = function(evaluation)
{
  DominoWorkItem.superclass.propagateStatus.call(this, evaluation);
  var excStatus = this.getExerciseStatus();
  if(!this.bEvaluated && !this.bStopped && !this.evaluateRequested)
  {
    if ( excStatus.nCorrect == excStatus.nCorrectStatus && excStatus.nWrongStatus == 0)
    {
      this.evaluateRequested = true;
      this.evaluate();
      this.evaluateRequested = false;
    }
  }
}
DominoWorkItem.prototype.reset = function()
{
  ;
  DominoWorkItem.superclass.reset.call(this);
  if ( this.firstEvaluation )
  {
    this.firstEvaluation.setActive(true, 'user');
  }
  this.propagateStatus();
}
DominoWorkItem.prototype.start = function()
{
  ;
  for (var id in this.aEvaluations)
  {
    this.aEvaluations[id].setChangeForDisabledOnReset(false);
  }
  DominoWorkItem.superclass.start.call(this);
}
