/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>BasicQeaTipStrategy</DEPENDS>
    <DEPENDS>ShowCharactersQeaTipStrategy</DEPENDS>
    <DEPENDS>ShowFirstCharacterQeaTipStrategy</DEPENDS>
    <DEPENDS>CorrectCharactersQeaTipStrategy</DEPENDS>
</DEPENDENCIES>
*/
ShowCharactersQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
ShowCharactersQeaTipStrategy.prototype.constructor = ShowCharactersQeaTipStrategy;
ShowCharactersQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function ShowCharactersQeaTipStrategy(sId, nMax, bJustUserSelect)
{
  if (sId) { this.init(sId, nMax, bJustUserSelect); }
}
ShowCharactersQeaTipStrategy.prototype.init = function(sId, nMax, bJustUserSelect)
{
  ;
  if (!nMax)
  {
    this.nMax = -1;
  }
  else
  {
    this.nMax = nMax;
  }
  this.bJustUserSelect = bJustUserSelect;
  ShowCharactersQeaTipStrategy.superclass.init.call(this, sId);
  this.bCanCycleTips = false; 
}
ShowCharactersQeaTipStrategy.prototype.hasShowTip = function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  return ShowCharactersQeaTipStrategy.superclass.hasShowTip.call(this, bShow, bStepByStep, bSolutable, false);
}
ShowCharactersQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = evaluation.hasUserFocus();
  }
  if (bHasTip)
  {
    var sCorrectText = evaluation.getAnswer().getText();
    if(evaluation.getQuestion().getActiveComplement())
    {
      var sActualText = evaluation.getQuestion().getActiveComplement().getText();
      if (sActualText != sCorrectText.substring(0,sActualText.length))
      {
        bHasTip = false;
      }
      if (bHasTip)
      {
        if (sActualText.length == sCorrectText.length)
        {
          bHasTip = false;
        }
      }
      if (bHasTip)
      {
        if (this.nMax != -1)
        {
          if (sActualText.length >= this.nMax)
          {
            bHasTip = false;
          }
        }
      }
    }
    else
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
ShowCharactersQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var sCorrectText = evaluation.getAnswer().getText();
  var sText = "";
  if(evaluation.getQuestion().getActiveComplement())
  {
    var sActualText = evaluation.getQuestion().getActiveComplement().getText();
    sText = sCorrectText.substring(0, sActualText.length+1);
  }
  else
  {
    sText = sCorrectText.substring(0,1);
  }
  if (sText == sCorrectText)
  {
     evaluation.setActive(true, 'system_set');
  }
  else
  {
    var answer = this.workItem.getOrCreateAnswerByText(sText);
    var e = this.workItem.getOrCreateEvaluation(evaluation.getQuestion(), answer);
    e.setActive(true, 'system_setpartial');
    this.workItem.willChange(evaluation);
    evaluation.setSystemPartialConstuction(true); 
  }
}
ShowFirstCharacterQeaTipStrategy.prototype             = new ShowCharactersQeaTipStrategy();
ShowFirstCharacterQeaTipStrategy.prototype.constructor = ShowFirstCharacterQeaTipStrategy;
ShowFirstCharacterQeaTipStrategy.superclass            = ShowCharactersQeaTipStrategy.prototype;
function ShowFirstCharacterQeaTipStrategy(sId, bJustUserSelect)
{
  if (sId) { this.init(sId,1, bJustUserSelect); }
}
CorrectCharactersQeaTipStrategy.prototype             = new BasicQeaTipStrategy();
CorrectCharactersQeaTipStrategy.prototype.constructor = CorrectCharactersQeaTipStrategy;
CorrectCharactersQeaTipStrategy.superclass            = BasicQeaTipStrategy.prototype;
function CorrectCharactersQeaTipStrategy(sId, bJustUserSelect)
{
  if (sId) { this.init(sId, bJustUserSelect); }
}
CorrectCharactersQeaTipStrategy.prototype.init = function(sId, bJustUserSelect)
{
  ;
  CorrectCharactersQeaTipStrategy.superclass.init.call(this, sId);
  this.bCanCycleTips = false; 
  this.bJustUserSelect = bJustUserSelect;
}
CorrectCharactersQeaTipStrategy.prototype.hasShowTip = function(bShow, bStepByStep, bSolutable, bCycleTips)
{
  return CorrectCharactersQeaTipStrategy.superclass.hasShowTip.call(this, bShow, bStepByStep, bSolutable, false);
}
CorrectCharactersQeaTipStrategy.prototype.evaluationHasTip = function(evaluation, bStepByStep)
{
  ;
  var bHasTip = true;
  if (bHasTip)
  {
    bHasTip = evaluation.isSolution() && !evaluation.isActive();
  }
  if (bHasTip)
  {
    bHasTip = !evaluation.hasOffItem();
  }
  if (this.bJustUserSelect && bHasTip)
  {
    bHasTip = evaluation.hasUserFocus();
  }
  if (bHasTip)
  {
    var sCorrectText = evaluation.getAnswer().getText();
    if(evaluation.getQuestion().getActiveComplement())
    {
      var sActualText = evaluation.getQuestion().getActiveComplement().getText();
      if (sActualText == sCorrectText.substring(0,sActualText.length))
      {
        bHasTip = false;
      }
    }
    else
    {
      bHasTip = false;
    }
  }
  return bHasTip;
}
CorrectCharactersQeaTipStrategy.prototype.evaluationShowTip = function(evaluation, bStepByStep)
{
  ;
  var sCorrectText = evaluation.getAnswer().getText();
  var i = 0;
  if(evaluation.getQuestion().getActiveComplement())
  {
    var sActualText = evaluation.getQuestion().getActiveComplement().getText();
    while (sActualText.charAt(i) == sCorrectText.charAt(i))
    {
      i++;
    }
  }
  var sText = '';
  if (i < sActualText.length)
  {
    sText = sCorrectText.substring(0,i+1) + sActualText.substring(i+1);
  }
  else
  {
    sText = sCorrectText;
  }
  var answer = this.workItem.getOrCreateAnswerByText(sText);
  var e = this.workItem.getOrCreateEvaluation(evaluation.getQuestion(), answer);
  e.setActive(true, 'system_setpartial');
  this.workItem.willChange(evaluation);
  evaluation.setSystemPartialCorrection(true); 
}
ShowCharactersOnSelectedQeaTipStrategy.prototype             = new ShowCharactersQeaTipStrategy();
ShowCharactersOnSelectedQeaTipStrategy.prototype.constructor = ShowCharactersOnSelectedQeaTipStrategy;
ShowCharactersOnSelectedQeaTipStrategy.superclass            = ShowCharactersQeaTipStrategy.prototype;
function ShowCharactersOnSelectedQeaTipStrategy(sId)
{
  if (sId) { this.init(sId,0, true); }
}
ShowFirstCharacterOnSelectedQeaTipStrategy.prototype             = new ShowFirstCharacterQeaTipStrategy();
ShowFirstCharacterOnSelectedQeaTipStrategy.prototype.constructor = ShowFirstCharacterOnSelectedQeaTipStrategy;
ShowFirstCharacterOnSelectedQeaTipStrategy.superclass            = ShowFirstCharacterQeaTipStrategy.prototype;
function ShowFirstCharacterOnSelectedQeaTipStrategy(sId)
{
  if (sId) { this.init(sId,1, true); }
}
CorrectCharactersOnSelectedQeaTipStrategy.prototype             = new CorrectCharactersQeaTipStrategy();
CorrectCharactersOnSelectedQeaTipStrategy.prototype.constructor = CorrectCharactersOnSelectedQeaTipStrategy;
CorrectCharactersOnSelectedQeaTipStrategy.superclass            = CorrectCharactersQeaTipStrategy.prototype;
function CorrectCharactersOnSelectedQeaTipStrategy(sId)
{
  if (sId) { this.init(sId,true); }
}
