/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Globals</DEPENDS>
</DEPENDENCIES>
*/
function JokerController(sId, maxUsageCount)
{
	if (sId)
		this.init(sId, maxUsageCount);
}
JokerController.prototype.init = function(sId, maxUsageCount)
{
	;
	this.sId = sId;
	this.maxUsageCount = maxUsageCount;
	this.enabled = false;
	this.used = 0;
	this.jokerStrategy = null;
	this.aEnabledHandles = new Array();
	this.aDisabledHandles = new Array();
	this.aDepletedHandles = new Array();
}
JokerController.prototype.setToggle = function(toggle)
{
	this.toggle = toggle;
}
JokerController.prototype.start = function()
{
	if (this.toggle.isOn())
		this.deplete();
}
JokerController.prototype.getId = function()
{
	return this.sId;
}
JokerController.prototype.setJokerStrategy = function(jokerStrategy)
{
	this.jokerStrategy = jokerStrategy;
}
JokerController.prototype.enableJoker = function()
{
	this.enabled = true;
	this.notifyListeners(this.aEnabledHandles);
}
JokerController.prototype.getEnableJokerAction = function()
{
	;
	return new ObjectMethodAction(this, "enableJoker");
}
JokerController.prototype.addJokerEnabledHandle = function(action)
{
	;
	if (action)
		this.aEnabledHandles.push(action);
}
JokerController.prototype.disableJoker = function()
{
	this.enabled = false;
	this.notifyListeners(this.aDisabledHandles);
}
JokerController.prototype.getDisableJokerAction = function()
{
	return new ObjectMethodAction(this, "disableJoker");
}
JokerController.prototype.addJokerDisabledHandle = function(action)
{
	if (action)
		this.aDisabledHandles.push(action);
}
JokerController.prototype.shouldPlayJoker = function()
{
	if (this.enabled)
	{
		if (this.used < this.maxUsageCount)
		{
			this.used++;
			this.toggle.setOn();
			if (this.jokerStrategy)
				this.jokerStrategy.playJoker();
		}
		if (this.used >= this.maxUsageCount)
		{
			this.notifyListeners(this.aDepletedHandles);
		}
	}
}
JokerController.prototype.getPlayJokerAction = function()
{
	return new ObjectMethodAction(this, "shouldPlayJoker");
}
JokerController.prototype.addJokerPlayedHandle = function(action)
{
	if (this.jokerStrategy)
		this.jokerStrategy.addJokerPlayedHandle(action);
}
JokerController.prototype.deplete = function(num)
{
	if (num)
	{
		this.used += num;
	}
	else
	{
		this.used = this.maxUsageCount;
	}
	if (this.used >= this.maxUsageCount)
	{
		this.notifyListeners(this.aDepletedHandles);
	}
}
JokerController.prototype.getDepleteAction = function()
{
	return new ObjectMethodAction(this, "deplete");
}
JokerController.prototype.addJokerDepletedHandle = function(action)
{
	if (action)
		this.aDepletedHandles.push(action);
}
JokerController.prototype.notifyListeners = function(handles)
{
	for (var i = 0; i < handles.length; i++)
	{
		handles[i].invoke();
	}
}
