/*
<DEPENDENCIES>
    <DEPENDS>Browser</DEPENDS>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Slider</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
</DEPENDENCIES>
*/
PagingSlider.prototype             = new Slider();
PagingSlider.prototype.constructor = PagingSlider;
PagingSlider.superclass            = Slider.prototype;
function PagingSlider(name, parent)
{
    if (name) this.init(name, parent);
    ;
} 
PagingSlider.prototype.init = function(name, parent)
{
    ;
    PagingSlider.superclass.init.call(this, name, parent);
    this.pageNumbers = new Array();
    this.middlePageIndex = 1;
    this.activePage = 1; 
    this.scrollToPageCompleteListenerAction = new Array();
}
PagingSlider.prototype.setSurroundingElement = function(elementId)
{
    ;
    this.surroundingElement = elementId;
}
PagingSlider.prototype.addPageNumber = function(pageNumberId)
{
    ;
    this.pageNumbers[this.pageNumbers.length] = pageNumberId;
}
PagingSlider.prototype.addScrollToPageCompleteListenerAction = function(action)
{
    this.scrollToPageCompleteListenerAction[this.scrollToPageCompleteListenerAction.length] = action;
}
PagingSlider.prototype.invokeScrollToPageCompleteListenerActions = function()
{
    if (this.scrollToPageCompleteListenerAction.length > 0)
    {
        for (var i = 0; i < this.scrollToPageCompleteListenerAction.length; i++)
        {
            this.scrollToPageCompleteListenerAction[i].invoke();
        }
    }
}
PagingSlider.prototype.onePageRight = function()
{
    if(this.activePage != this.pageNumbers.length)
    {
        if (this.pagingBroker)
        {
            this.pagingBroker.getJumpToAction(this.activePage).invoke();
        }
        else
        {
            this.scrollToPage(this.activePage + 1);
        }
    }
}
PagingSlider.prototype.onePageLeft = function()
{
    if(this.activePage != 1)
    {
        if (this.pagingBroker)
        {
            this.pagingBroker.getJumpToAction(this.activePage - 2).invoke();
        }
        else
        {
            this.scrollToPage(this.activePage - 1);
        }
    }
}
PagingSlider.prototype.scrollToPageFromBroker = function(pageNumber)
{
 	this.scrollToPage(pageNumber + 1);
}
PagingSlider.prototype.scrollToPage = function(pageNumber)
{
    if (!this.scrollingActive)
    {
        this.activePage = pageNumber;
        var actualMiddlePage = this.middlePageIndex + this.firstVisiblePageNumber - 1;
        var pagesToScroll = pageNumber - actualMiddlePage;
        if (pagesToScroll > 0)
        {
            this.scrollPageLeft(pagesToScroll);
        }
        if (pagesToScroll < 0)
        {
            this.scrollPageRight(Math.abs(pagesToScroll));
        }
        if (pagesToScroll == 0)
        {
            this.invokeScrollToPageCompleteListenerActions();
        }
    }
}
PagingSlider.prototype.scrollPageRight = function(pages)
{
    if (!pages)
    {
        pages = 1;
        this.activePage--;
    }
    if ((this.firstVisiblePageNumber > 1) && !this.scrollingActive)
    {
        this.removeSlideId(this.pageNumbers[this.firstVisiblePageNumber + this.maxVisiblePageNumbers - 2]);
        Browser.changeStyleById(this.pageNumbers[this.firstVisiblePageNumber + this.maxVisiblePageNumbers - 2], 'visibility', 'hidden');
        this.tempScrollingCompleteListenerAction = new ObjectMethodAction(this, 'doneScrollPageRight', pages);
        this.addScrollingCompleteListenerAction(this.tempScrollingCompleteListenerAction);
        this.slideRight(this.pageNumberDimensionX);
    }
    else
        this.invokeScrollToPageCompleteListenerActions();
}
PagingSlider.prototype.doneScrollPageRight = function(pages)
{
    this.firstVisiblePageNumber--;
    this.lastVisiblePageNumber--;
    Browser.changeStyleById(this.pageNumbers[this.firstVisiblePageNumber - 1], 'left', this.firstVisibleElementXPos + 'px');
    Browser.changeStyleById(this.pageNumbers[this.firstVisiblePageNumber - 1], 'visibility', '');
    this.addSlideId(this.pageNumbers[this.firstVisiblePageNumber - 1]);
    this.removeScrollingCompleteListenerAction(this.tempScrollingCompleteListenerAction);
    if (--pages > 0) this.scrollPageRight(pages);
    else
        this.invokeScrollToPageCompleteListenerActions();
}
PagingSlider.prototype.scrollPageLeft = function(pages)
{
    if (!pages)
    {
        pages = 1;
        this.avtivePage++;
    }
    if ((this.lastVisiblePageNumber < (this.pageNumbers.length - 2)) && !this.scrollingActive)
    {
        this.removeSlideId(this.pageNumbers[this.firstVisiblePageNumber - 1]);
        Browser.changeStyleById(this.pageNumbers[this.firstVisiblePageNumber - 1], 'visibility', 'hidden');
        this.tempScrollingCompleteListenerAction = new ObjectMethodAction(this, 'doneScrollPageLeft', pages);
        this.addScrollingCompleteListenerAction(this.tempScrollingCompleteListenerAction);
        this.slideLeft(this.pageNumberDimensionX);
    }
    else
        this.invokeScrollToPageCompleteListenerActions();
}
PagingSlider.prototype.doneScrollPageLeft = function(pages)
{
    this.firstVisiblePageNumber++;
    this.lastVisiblePageNumber++;
    Browser.changeStyleById(this.pageNumbers[this.firstVisiblePageNumber + this.maxVisiblePageNumbers - 2], 'left', this.lastVisibleElementXPos + 'px');
    Browser.changeStyleById(this.pageNumbers[this.firstVisiblePageNumber + this.maxVisiblePageNumbers - 2], 'visibility', '');
    this.addSlideId(this.pageNumbers[this.firstVisiblePageNumber + this.maxVisiblePageNumbers - 2]);
    this.removeScrollingCompleteListenerAction(this.tempScrollingCompleteListenerAction);
    if (--pages > 0) this.scrollPageLeft(pages);
    else
        this.invokeScrollToPageCompleteListenerActions();
}
PagingSlider.prototype.start = function()
{
    this.pageNumberDimensionX = Browser.getElementById(this.pageNumbers[0]).offsetWidth;
    this.pageNumberDimensionY = Browser.getElementById(this.pageNumbers[0]).offsetHeight;
    this.myDimensionX = Browser.getElementById(this.surroundingElement).offsetWidth;
    this.totalPageButtonsWidth = 0;
    this.firstVisiblePageNumber = 1;
    for (var i=0; i < this.pageNumbers.length; i++) 
        this.totalPageButtonsWidth += Browser.getElementById(this.pageNumbers[i]).offsetWidth;
    ;
    this.maxVisiblePageNumbers = Math.floor(this.myDimensionX / this.pageNumberDimensionX);
    ;
    if (this.maxVisiblePageNumbers >= this.pageNumbers.length) 
    {
        this.isScrollingNeeded = false;
        ;
        this.startX = Math.floor((this.myDimensionX - this.totalPageButtonsWidth) / 2);
        for (var i = 0; i < this.pageNumbers.length; i++)
        {
            if (i == 0) this.firstVisibleElementXPos = this.startX;
            if (i == (this.maxVisiblePageNumbers - 1))
            {
                this.lastVisibleElementXPos = this.startX;
                this.lastVisiblePageNumber = i - 1;
            }
            ;
            Browser.getElementById(this.pageNumbers[i]).style.position = "absolute";
            Browser.getElementById(this.pageNumbers[i]).style.left = this.startX + "px";
            this.startX += this.pageNumberDimensionX;
        }
    }
    else 
    {
        this.isScrollingNeeded = true;
        ;
        this.startX = Math.floor((this.myDimensionX - (this.maxVisiblePageNumbers * this.pageNumberDimensionX)) / 2);
        for (var i = 0; i < this.maxVisiblePageNumbers; i++)
        {
            if (i == 0) this.firstVisibleElementXPos = this.startX;
            if (i == (this.maxVisiblePageNumbers - 1))
            {
                this.lastVisibleElementXPos = this.startX;
                this.lastVisiblePageNumber = i - 1;
            }
            ;
            Browser.getElementById(this.pageNumbers[i]).style.position = "absolute";
            Browser.getElementById(this.pageNumbers[i]).style.left = this.startX + "px";
            this.startX += this.pageNumberDimensionX;
        }
        for (var i = this.maxVisiblePageNumbers; i < this.pageNumbers.length; i++)
        {   
            Browser.getElementById(this.pageNumbers[i]).style.visibility = "hidden";
        }
    }
    this.middlePageIndex = Math.ceil(this.maxVisiblePageNumbers / 2);
    for (var i = 0; i < (this.maxVisiblePageNumbers > this.pageNumbers.length ? this.pageNumbers.length : this.maxVisiblePageNumbers); i++)
    {
        this.addSlideId(this.pageNumbers[i]);
    }
    for(var x in this.pageNumbers)
    {
      Browser.getElementById(this.pageNumbers[x]).style.visibility = 'inherit';
    }
}
