/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
    <DEPENDS>Actions</DEPENDS>
    <DEPENDS>Broker</DEPENDS>
    <DEPENDS>IgnoreRuntimeParameterAction</DEPENDS>
    <DEPENDS>ServiceRegistryAccessor</DEPENDS>
</DEPENDENCIES>
*/
ScreenBroker.prototype             = new Broker();
ScreenBroker.prototype.constructor = ScreenBroker;
ScreenBroker.superclass            = Broker.prototype;
function ScreenBroker()
{
    ;
    this.screenController = null;
    this.bookmarkable = false;
     ScreenBroker.superclass.init.call(this, 'ScreenBroker');
     window.screenBroker = this;
     this.beforeLeavePageAction = null;
}
ScreenBroker.prototype.setScreenController = function(screenController)
{
    this.screenController = screenController;
}
ScreenBroker.prototype.getId = function()
{
    return 'ScreenBroker';
}
ScreenBroker.prototype.doReplace = function(extURL)
{
    ;
    var paramArray = new Array();
    paramArray[0] = extURL;
    this.getMessage('replace', paramArray);
}
ScreenBroker.prototype.addReplaceHandle = function(action)
{
    this.registerAction('replace', action);
}
ScreenBroker.prototype.getReplaceAction = function(extURL)
{
    return new ObjectMethodAction(this, 'replace', extURL);
}
ScreenBroker.prototype.replace = function(extURL)
{
    if (this.screenController)
        this.screenController.shouldReplace(extURL);
    else
        this.doReplace(extURL);
}
ScreenBroker.prototype.doReload = function()
{
    ;
    this.getMessage('reload');
}
ScreenBroker.prototype.addReloadHandle = function(action)
{
    this.registerAction('reload', action);
}
ScreenBroker.prototype.getReloadAction = function()
{
    return new ObjectMethodAction(this, 'reload');
}
ScreenBroker.prototype.reload = function()
{
    if (this.screenController)
        this.screenController.shouldReload();
    else
        this.doReload();
}
ScreenBroker.prototype.doPopup = function(extURL, windowName, width, height, scrollbars, resizable)
{
    ;
    var paramArray = new Array();
    paramArray[0] = extURL;
    paramArray[1] = windowName;
    paramArray[2] = width;
    paramArray[3] = height;
    paramArray[4] = scrollbars;
    paramArray[5] = resizable;
    this.getMessage('popup', paramArray);
}
ScreenBroker.prototype.addPopupHandle = function(action)
{
    this.registerAction('popup', action);
}
ScreenBroker.prototype.getPopupAction = function(id, extURL, windowName, width, height, scrollbars, resizable)
{
    return new ObjectMethodAction(this, 'popup',
                id, extURL, windowName, width, height, scrollbars, resizable);
}
ScreenBroker.prototype.popup = function(id, extURL, windowName, width, height, scrollbars, resizable)
{
    extURL = this.getURL(id, extURL);
    if (this.screenController)
        this.screenController.shouldPopup(extURL, windowName, width, height, scrollbars, resizable)
    else
        this.doPopup(extURL, windowName, width, height, scrollbars, resizable)
}
ScreenBroker.prototype.doIFrame = function(extURL, windowName)
{
    ;
    var paramArray = new Array();
    paramArray[0] = extURL;
    paramArray[1] = windowName;
    this.getMessage('iframe', paramArray);
}
ScreenBroker.prototype.addIFrameHandle = function(action)
{
    this.registerAction('iframe', action);
}
ScreenBroker.prototype.getIFrameAction = function(extURL, windowName)
{
    return new ObjectMethodAction(this, 'iframe',
                extURL, windowName);
}
ScreenBroker.prototype.iframe = function(extURL, windowName)
{
    if (this.screenController)
        this.screenController.shouldIFrame(extURL, windowName)
    else
        this.doIFrame(extURL, windowName)
}
ScreenBroker.prototype.doInvokeServletMethod = function(extURL)
{
    ;
    var paramArray = new Array();
    paramArray[0] = extURL;
    this.getMessage('invokeServletMethod', paramArray);
}
ScreenBroker.prototype.addInvokeServletMethodHandle = function(action)
{
    this.registerAction('invokeServletMethod', action);
}
ScreenBroker.prototype.getInvokeServletMethodAction = function(extURL, successAction, errorAction)
{
    return new ObjectMethodAction(this, 'invokeServletMethod', extURL, successAction, errorAction);
}
ScreenBroker.prototype.invokeServletMethod = function(extURL, callBackAction, errorAction)
{
    if (this.screenController)
        this.screenController.shouldInvokeServletMethod(extURL, callBackAction, errorAction)
    else
        this.doInvokeServletMethod(extURL)
}
ScreenBroker.prototype.doCallServer = function(extURL)
{
    ;
    var paramArray = new Array();
    paramArray[0] = extURL;
    this.getMessage('callServer', paramArray);
}
ScreenBroker.prototype.addCallServerHandle = function(action)
{
    this.registerAction('callServer', action);
}
ScreenBroker.prototype.getCallServerAction = function(extURL, successAction, errorAction)
{
    return new ObjectMethodAction(this, 'callServer', extURL, successAction, errorAction);
}
ScreenBroker.prototype.callServer = function(extURL, callBackAction, errorAction)
{
    if (this.screenController)
        this.screenController.shouldCallServer(extURL, callBackAction, errorAction)
    else
        this.doCallServer(extURL)
}
ScreenBroker.prototype.doClosePopup = function(windowName)
{
    ;
    var paramArray = new Array();
    paramArray[0] = windowName;
    this.getMessage('closePopup', paramArray);
}
ScreenBroker.prototype.addClosePopupHandle = function(action)
{
    this.registerAction('closePopup', action);
}
ScreenBroker.prototype.getClosePopupAction = function(windowName)
{
    return new ObjectMethodAction(this, 'closePopup', windowName);
}
ScreenBroker.prototype.closePopup = function(windowName)
{
    if (this.screenController)
        this.screenController.shouldClosePopup(windowName)
    else
        this.doClosePopup(windowName)
}
ScreenBroker.prototype.doReloadPopup = function(extURL, windowName)
{
    ;
    var paramArray = new Array();
    paramArray[0] = extURL;
    paramArray[1] = windowName;
    this.getMessage('reloadPopup', paramArray);
}
ScreenBroker.prototype.addReloadPopupHandle = function(action)
{
    this.registerAction('reloadPopup', action);
}
ScreenBroker.prototype.getReloadPopupAction = function(extURL, windowName)
{
    return new ObjectMethodAction(this, 'reloadPopup', extURL, windowName);
}
ScreenBroker.prototype.reloadPopup = function(extURL, windowName)
{
    if (this.screenController)
        this.screenController.shouldReloadPopup(extURL, windowName)
    else
        this.doReloadPopup(extURL, windowName)
}
ScreenBroker.prototype.doLoaded = function()
{
    ;
    this.getMessage('loaded');
}
ScreenBroker.prototype.addLoadedHandle = function(action)
{
    this.registerAction('loaded', action);
}
ScreenBroker.prototype.getLoadedAction = function()
{
    return new ObjectMethodAction(this, 'loaded');
}
ScreenBroker.prototype.loaded = function()
{
    if (this.screenController)
        this.screenController.shouldLoaded();
    else
        this.doLoaded();
}
ScreenBroker.prototype.doUnload = function()
{
    ;
    this.getMessage('unloaded');
}
ScreenBroker.prototype.addUnloadHandle = function(action)
{
    this.registerAction('unloaded', action);
}
ScreenBroker.prototype.getUnloadAction = function()
{
    return new ObjectMethodAction(this, 'unloaded');
}
ScreenBroker.prototype.unloaded = function()
{
    if (this.screenController)
        this.screenController.shouldUnload();
    else
        this.doUnload();
}
ScreenBroker.prototype.doOpenWindow = function(url, target)
{
    ;
    var paramArray = new Array();
    paramArray[0] = url;
    paramArray[1] = target;
    this.getMessage('openWindow', paramArray);
}
ScreenBroker.prototype.addOpenWindowHandle = function(action)
{
    this.registerAction('openWindow', action);
}
ScreenBroker.prototype.getOpenWindowAction = function(id, url, target)
{
    return new ObjectMethodAction(this, 'openWindow', id, url, target);
}
ScreenBroker.prototype.openWindow = function(id, url, target)
{
    url = this.getURL(id, url);
    if (this.screenController)
        this.screenController.shouldOpenWindow(url, target);
    else
        this.doOpenWindow(url, target);
}
ScreenBroker.prototype.doOpenerReplace = function(internalURL)
{
    ;
    var paramArray = new Array();
    paramArray[0] = internalURL;
    this.getMessage('openerReplace', paramArray);
}
ScreenBroker.prototype.addOpenerReplaceHandle = function(action)
{
    this.registerAction('openerReplace', action);
}
ScreenBroker.prototype.getOpenerReplaceAction = function(internalURL)
{
    return new ObjectMethodAction(this, 'openerReplace', internalURL);
}
ScreenBroker.prototype.openerReplace = function(internalURL)
{
    if (this.screenController)
        this.screenController.shouldOpenerReplace(internalURL);
    else
        this.doOpenerReplace(internalURL);
}
ScreenBroker.prototype.getAddUserMarkerOpenerAction = function(markerId)
{
    var obj = new Object();
    obj.invoke = function()
    {
        if (opener && opener.screenBroker)
            opener.screenBroker.addUserMarker(markerId);
    };
    return obj;
}
ScreenBroker.prototype.getAddUserMarkerAction = function(markerId)
{
    return new ObjectMethodAction(this, 'addUserMarker', markerId);
}
ScreenBroker.prototype.addUserMarker = function(markerId)
{
    ;
    if (this.screenController)
        this.screenController.shouldAddUserMarker(markerId);
    else
        this.doAddUserMarker(markerId);
}
ScreenBroker.prototype.doAddUserMarker = function(markerId)
{
    var paramArray = new Array();
    paramArray[0] = markerId;
    this.getMessage('addUserMarker', paramArray);
}
ScreenBroker.prototype.addAddUserMarkerHandle = function(action)
{
    this.registerAction('addUserMarker', action);
}
ScreenBroker.prototype.setBookmarkable = function(bookmarkEnable)
{
    ;
    this.bookmarkable = bookmarkEnable;
}
ScreenBroker.prototype.doNotifyPopupAware = function(screenBroker)
{
    ;
    var paramArray = new Array();
    paramArray[0] = screenBroker;
    this.getMessage('notifyPopupAware', paramArray);
}
ScreenBroker.prototype.addNotifyPopupAwareHandle = function(action)
{
    this.registerAction('notifyPopupAware', action);
}
ScreenBroker.prototype.getNotifyPopupAwareAction = function(screenBroker)
{
    return new ObjectMethodAction(this, 'notifyPopupAware', screenBroker);
}
ScreenBroker.prototype.notifyPopupAware = function(screenBroker)
{
    if (this.screenController)
        this.screenController.shouldNotifyPopupAware(screenBroker)
    else
        this.doNotifyPopupAware(screenBroker)
}
ScreenBroker.prototype.doRequestLogout = function()
{
    ;
    this.getMessage('requestLogout');
}
ScreenBroker.prototype.addRequestLogoutHandle = function(action)
{
    this.registerAction('requestLogout', action);
    window.Quit = function()
    {
        window.screenBroker.getRequestLogoutAction().invoke();
    }
}
ScreenBroker.prototype.getRequestLogoutAction = function()
{
    return new ObjectMethodAction(this, 'requestLogout');
}
ScreenBroker.prototype.requestLogout = function()
{
    this.doRequestLogout();
}
ScreenBroker.prototype.doLogout = function()
{
    ;
    this.getMessage('logout');
}
ScreenBroker.prototype.getLogoutAction = function()
{
    return new ObjectMethodAction(this, 'logout');
}
ScreenBroker.prototype.addLogoutHandle = function(action)
{
    this.registerAction('logout', action);
}
ScreenBroker.prototype.logout = function()
{
    if (this.screenController)
        this.screenController.shouldLogout();
    else
        this.doLogout();
}
ScreenBroker.prototype.doLeave = function(screenBroker)
{
    ;
    var paramArray = new Array();
    paramArray[0] = screenBroker;
    this.getMessage('leave', paramArray);
}
ScreenBroker.prototype.addLeaveHandle = function(action)
{
    this.registerAction('leave', action);
}
ScreenBroker.prototype.getLeaveAction = function(screenBroker)
{
    return new ObjectMethodAction(this, 'leave', screenBroker);
}
ScreenBroker.prototype.leave = function(screenBroker)
{
    if (this.screenController)
        this.screenController.shouldLeave(screenBroker)
    else
        this.doLeave(screenBroker)
}
ScreenBroker.prototype.getURL = function(id, defaulturl)
{
	
	if (id)
    {
		var serviceregistry = ServiceRegistryAccess.getServiceRegistry();
		if (serviceregistry)
		{
			var linkservice = serviceregistry.getService("linkservice");
			if (linkservice)
			{
				var url = linkservice.getLink(id);
				if (url)
					defaulturl = url;
			}
		}
   	}
   	return defaulturl;
}
