/*
<DEPENDENCIES>
    <DEPENDS>Logger</DEPENDS>
</DEPENDENCIES>
*/
function SelectionDisplay(sId, emptyText, prefixText, deviderText, suffixText, justMin, justMax)
{
	if (sId)
	{
		this.init(sId, emptyText, prefixText, deviderText, suffixText, justMin, justMax);
	}
}
SelectionDisplay.prototype.init = function(sId, emptyText, prefixText, deviderText, suffixText, justMin, justMax)
{
	this.sId = sId;
	this.emptyText = emptyText;
	this.prefixText = prefixText;
	this.deviderText = deviderText;
	this.suffixText = suffixText;
	this.justMin = justMin;
	this.justMax = justMax;
	this.displayChangedHandles = new Array();
}
SelectionDisplay.prototype.getId = function()
{
	return this.sId;
}
SelectionDisplay.prototype.setSelectionModel = function(model)
{
	this.model = model;
}
SelectionDisplay.prototype.start = function()
{
	this.selectionModelChanged(this.model);
}
SelectionDisplay.prototype.selectionModelChanged = function(model)
{
	if (this.model)
	{
		var text;
		var selectedValues = this.model.getActiveValues();
		if (selectedValues.length == 0)
			text = this.emptyText;
		else if (this.justMin == true || this.justMax == true)
		{
			text = this.prefixText;
			if (this.justMin == true && this.justMax == false)
			{
				text += selectedValues[0].getValue();
			}
			else if (this.justMin == false)
			{
				text += selectedValues[selectedValues.length -1].getValue();
			}
			else
			{
				text += selectedValues[0].getValue();
				text += this.deviderText;
				text += selectedValues[selectedValues.length -1].getValue();
			}
		}
		else
		{
			text = this.prefixText;
			for (var i = 0; i < selectedValues.length; i ++)
			{
				text += selectedValues[i].getValue();
				if (i < (selectedValues.length - 1))
					text += this.deviderText;
			}
			text += this.suffixText;
		}
		this.fireDisplayChanged(text);
	}
}
SelectionDisplay.prototype.addDisplayChangedHandle = function(action)
{
	this.displayChangedHandles.push(action);
}
SelectionDisplay.prototype.fireDisplayChanged = function(text)
{
	for (var i = 0; i < this.displayChangedHandles.length; i ++)
	{
		this.displayChangedHandles[i].invoke(text);
	}
}
