/*
	<DEPENDENCIES>
		<DEPENDS>Logger</DEPENDS>
		<DEPENDS>Actions</DEPENDS>
		<DEPENDS>LocationService</DEPENDS>
		<DEPENDS>LMSSuspendDataSerializer</DEPENDS>
	</DEPENDENCIES>
	*/
function LMSConnectorManagerStandalone()
{
	;
	this.suspendDataSerializer = null;
	this.startDate = 0;
	this.structureName = null;
	this.achievementService = null;
	this.structureService = null;
	this.evaluationService = null;
	this.locationService = null;
	this.lastVisitedLocation = 0;
	
	this.score = new ScoreStatistics(0, 0, 0, 0, 1);
	this.sessiontime = '00:00:00.0';
	this.finished = false;
	
}
LMSConnectorManagerStandalone.prototype.start = function()
{
	
	serviceregistry.registerService('lmsconnector', this);
}
LMSConnectorManagerStandalone.prototype.initConnector = function()
{
	if (this.locationService.isInitialized()
			&& this.achievementService.isInitialized()
			&& this.propertyService.isInitialized()
			&& this.linkService.isInitialized()
			)
	{
		
		this.startDate = new Date().getTime();
		
		this.startWBT();
	}
}
LMSConnectorManagerStandalone.prototype.startWBT = function()
{
	var startloc = this.locationService.getStartLocation();
	parent.frames['mainframe'].location.replace(startloc);
}
LMSConnectorManagerStandalone.prototype.setStructureName = function(structureName)
{
	;
	this.structureName = structureName;
}
LMSConnectorManagerStandalone.prototype.setAchievementService = function(achievementService)
{
	;
	this.achievementService = achievementService;
	
	this.achievementService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerStandalone.prototype.setStructureService = function(structureService)
{
	;
	this.structureService = structureService;
}
LMSConnectorManagerStandalone.prototype.setEvaluationService = function(evaluationService)
{
	;
	this.evaluationService = evaluationService;
}
LMSConnectorManagerStandalone.prototype.setLocationService = function(locationService)
{
	;
	this.locationService = locationService;
	
	this.locationService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerStandalone.prototype.setPropertyService = function(propertyService)
{
	;
	this.propertyService = propertyService;
	
	this.propertyService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerStandalone.prototype.setLinkService = function(linkService)
{
	;
	this.linkService = linkService;
	
	this.linkService.registerLoadedListener(new ObjectMethodAction(this, "initConnector"));
}
LMSConnectorManagerStandalone.prototype.finishConnection = function()
{
	;
	
}
LMSConnectorManagerStandalone.prototype.notifyFinished = function(timeout)
{
	;
	this.finished = true;
}
LMSConnectorManagerStandalone.prototype.retrieveAchievementData = function()
{
	;
}
LMSConnectorManagerStandalone.prototype.setLastVisitedLocation= function(folderId, entryId) {
	if (entryId)
	{
		var folder =
		        this.structureService.getStructureEntry(this.structureName, folderId);
		var structureEntry =
				this.structureService.getStructureEntry(this.structureName, entryId);
		if (folder && structureEntry)
		{
			this.locationService.setLastVistedLocation(folder, structureEntry);
		}
		else if (structureEntry)
		{
			
			this.locationService.setInitialLastVisitedLocation(structureEntry.getURL());
		}
	}
}
LMSConnectorManagerStandalone.prototype.setInitialLastVisitedLocation = function(url)
{
	if (url)
	{
		this.locationService.setInitialLastVisitedLocation(url);
	}
}
LMSConnectorManagerStandalone.prototype.sendData = function()
{
	
}
LMSConnectorManagerStandalone.prototype.getSuspendDataSerializer = function()
{
	if (this.suspendDataSerializer == null)
		this.suspendDataSerializer =
				new LMSSuspendDataSerializer(this.evaluationService, this.locationService, this.structureName, this.structureService);
	return this.suspendDataSerializer;
}
LMSConnectorManagerStandalone.prototype.serializeSuspendData = function()
{
	return this.getSuspendDataSerializer().serializeSuspendData();
}
LMSConnectorManagerStandalone.prototype.deserializeSuspendData = function(serializeddata)
{
	this.getSuspendDataSerializer().deserializeSuspendData(serializeddata);
}
LMSConnectorManagerStandalone.prototype.computeTime = function()
{
	if (this.startDate != 0)
	{
		var currentDate = new Date().getTime();
		var elapsedSeconds = (currentDate - this.startDate) / 1000;
		var formattedTime = this.convertTotalSeconds(elapsedSeconds);
	}
	else
	{
		formattedTime = "00:00:00.0";
	}
	return formattedTime;
}
LMSConnectorManagerStandalone.prototype.convertTotalSeconds = function (ts)
{
	var sec = (ts % 60);
	ts -= sec;
	var tmp = (ts % 3600);
	
	ts -= tmp;
	
	
	sec = Math.round(sec * 100) / 100;
	var strSec = new String(sec);
	var strWholeSec = strSec;
	var strFractionSec = "";
	if (strSec.indexOf(".") != -1)
	{
		strWholeSec = strSec.substring(0, strSec.indexOf("."));
		strFractionSec = strSec.substring(strSec.indexOf(".") + 1, strSec.length);
	}
	if (strWholeSec.length < 2)
	{
		strWholeSec = "0" + strWholeSec;
	}
	strSec = strWholeSec;
	if (strFractionSec.length)
	{
		strSec = strSec + "." + strFractionSec;
	}
	if ((ts % 3600) != 0)
		var hour = 0;
	else var hour = (ts / 3600);
	if ((tmp % 60) != 0)
		var min = 0;
	else var min = (tmp / 60);
	if ((new String(hour)).length < 2)
		hour = "0" + hour;
	if ((new String(min)).length < 2)
		min = "0" + min;
	var rtnVal = hour + ":" + min + ":" + strSec;
	return rtnVal;
}
LMSConnectorManagerStandalone.prototype.trim = function(inputString)
{
	
	
	
	if (typeof inputString != "string")
	{
		return inputString;
	}
	var retValue = inputString;
	var ch = retValue.substring(0, 1);
	while (ch == " ")
	{ 
		retValue = retValue.substring(1, retValue.length);
		ch = retValue.substring(0, 1);
	}
	ch = retValue.substring(retValue.length - 1, retValue.length);
	while (ch == " ")
	{ 
		retValue = retValue.substring(0, retValue.length - 1);
		ch = retValue.substring(retValue.length - 1, retValue.length);
	}
	while (retValue.indexOf("  ") != -1)
	{ 
		retValue = retValue.substring(0, retValue.indexOf("  ")) + retValue.substring(retValue.indexOf("  ") + 1, retValue.length);
		
	}
	return retValue;
	
}
